2020-03-05 version 2020a
- Verbose output for numerical optimization: make the
  default more basic but add a new "full" setting for the
  set-variable "max_verbose"
- "wls" command: support the --cluster option
- "scatters" command: improve handling of daily data
- Work on lasso back-end (not public yet)
- New function instrings() to locate instances of a given
  string within an array of strings
- mpireduce() and mpiscatter(): accept a string variable
  for selection of the "op" argument
- feval(): handle functions that take no arguments
- sprintf(): fix potential breakage when used within a
  ternary query statement
- jsongetb(): support nested JSON arrays
- Reorganization of time-series model menu: add code to
  protect packages written for gretl < 2019d
- SVD: use faster divide-and-conquer lapack function
  where applicable
- complex(): make the second argument optional
- defarray(): treat scalar arguments as 1x1 matrices
- arrays: allow as function parameters and return values
- xlsx data importer: handle a wider variety of cases
- ODBC data importation: handle string-valued series
- OpenBLAS speed-up: limit the number of threads to the
  number of physical cores on the host machine
- Fix bug: possible buffer overrun on printing list of
  instruments for IV regression
- Fix bug: incorrect results when applying unary +/- to
  complex matrices
- MS windows packages: update OpenBLAS version
- Numerous small GUI fixes and enhancements

2019-12-22 version 2019d
- Add support for complex matrices, with new functions
  carg, cmod, complex, conj, ctrans, eiggen2, fft2, Re, Im
  and schur; documentation in a new chapter of the Gretl
  User's Guide
- MPI data transfer: enable sending of arrays, and speed
  up sending of bundles
- Enable nesting of arrays
- New function randperm() (Matlab-compatible, permutation
  and sampling without replacement)
- New function stdize() for standardization or centering
  of series, list or matrix; plus new "stdize" command
- mwrite() and mread(): treat "*.csv" filenames specially
  on both read and write to ensure correct round-trip
- "set" command: add new "boot_iters" argument to set the
  number of iterations used when computing impulse response
  functions with confidence interval
- Fix bug: possible crash on appending multiple lists to a
  list inside a bundle
- Fix bug: "fcast" could fail to produce dynamic out of
  sample forecasts in some cases where it ought to be OK
- Fix bug: "(" could in certain cases be misinterpreted as
  starting a series lag specification
- Fix bug: strsplit() could produce 1 less than the correct
  number of elements when "\n" is used as separator
- Fix obscure bug: ensure that a user-function does not
  return directly a variable passed as a const argument
- Fix obscure bug: ensure that a function cannot access
  the namespace of its caller, which could happen under
  certain special conditions
- Matrix row and column names: arrange for these to be
  preserved in a larger set of cases
- For various commands: document the --quiet option
- Functions ones(), zeros(), muniform(), mnormal(): make
  the second argument optional; the shape now defaults
  to a column vector
- Generalize the I() function: can now create a non-square
  matrix
- The resample() function: add an optional third argument
  to control the number of draws, for matrix input only
- "modtest" command with --autocorr option: add support for
  Wooldridge's first-order test for panel data
- "funcerr" command: add a function version of this
- "pkg" command: add "query" action plus --quiet option
- "system" command: support the --robust option, but only
  when estimation is via OLS
- "var" command: enable the "omit" test
- "set verbose": add a "comments" setting
- "outfile" command: add --tempfile option to use an
  automatically named temporary file
- "markers" command: add option to save observation marker
  strings in the form of an array
- Internals: speed up element-wise matrix calculation by
  use of function pointers
- "Send-to" (email) functionality: use libcurl and improve
  the user interface; it's now gmail-compatible
- GUI: don't close native database windows on "Clear data"
- GUI: beef up error-checking for the case of defining a
  dataset as a panel via index variables
- GUI: fix for failure of "freezing" plot data labels in
  some cases
- Builds for MS Windows and Mac: switch to use of libgsf
  for zipping/unzipping
- Update support for building gretl on MS Windows
- MS windows package: add new "Windows-10" theme

2019-07-02 version 2019c
- Fix bug: "dataset sortby" not handling missing values
  correctly on MS Windows
- Fix bug: possible crash on using the "fcast" command for
  out-of-sample forecasting after estimation of a VAR
- Fix bug: typeof() function not working correctly for
  string objects inside bundles and arrays
- Fix bug: robust variant of "chow" failing in case of
  exact collinearity in the augmented regression
- New function fzero(): find a root of a nonlinear function
- New function conv2d(): 2-dimensional convolution of two
  matrices
- New function flatten(): reduce array of matrices to single
  matrix or array of strings to single string
- New function msplitby(): split a matrix into an array of
  matrices
- "gnuplot" and "plot": add support for scriptable "recession
  bars"
- GUI plot editor: try to ensure that choice of font carries
  over in copying a plot to the clipboard
- svm() function: add support for ordinal data, plus small
  interface improvements
- mread() function: enable reading of delimited text matrix
  files, non-conformant with the mwrite() format
- sscanf() function: support conversion of an array of numeric
  strings to a column vector
- GUI model table: show up to three "significance" stars
- Remove the deprecated function isstring()

2019-05-21 version 2019b
- New command "panplot": plot a single panel-data series
- "print" command: new --range option to control the
  range to print for series, matrices, arrays and strings
- New command "bkw", now separated from the "vif" command
- "smpl" command: add --unit option for panel data
- "intreg" and "tobit" commands: add --opg option
- "fcast" command: add some support for panel data
- "add" command: ensure that the robust option for the
  target model is respected in the panel-data case
- "logistic" command: enable --robust, --cluster and
  --fixed-effects options
- "plot" (block) command: make the "data" argument optional,
  allowing creation of formula-based plots
- New accessor $now to get current time/date, plus new
  functions strftime() and strptime()
- New accessor $parnames to get array of parameter names
  from a model
- New function feval(): evaluate a function by name
- New function Lsolve(), using precomputed Cholesky factor
- New function isoweek() to get ISO 8601 week number
- seasonals() function: use ISO 8601 week numbers for dated
  weekly data
- epochday() function: support YYYYMMDD input
- randgen() function: support the logistic distribution
- firstobs() and lastobs() functions: add optional boolean
  argument to restrict the check to the current sample
- argname() function: add optional fallback argument
- Speed up rank() function for far-from-square matrices
- Stata dta importer: fix for opening of very large files
- Stata dta exporter: fix breakage on MS Windows
- LaTeX output fix: be sure to TeX-escape series names when
  printing var F-tests output
- Obscure fix: enable deletion of "time" from a list
  supplied as a function argument
- GUI convenience: remember dbnomics search string
- GUI: disallow execution of a script when one is already
  in progress (to prevent crashing)
- GUI: enable saving of model as bundle under model-window
  Save menu
- GUI, "View as equation" option for models: enable for
  cases with more than 5 regressors
- GUI fix: some of the example scripts referenced in the
  GUI command help were not being found
- Add configure option --disable-gmp: not recommended for
  general use, but can be helpful in some build contexts
  where libgmp is not readily available
- Allow use of "dataset sortby" in loops
- Document the --all-cols option for the "open" command
- User's Guide: beef up the Numerical Methods chapter
- Allow use of undefined symbols in the right-hand
  operand of "&&": don't flag an error unless the left-hand
  operand evaluates as true

2019-01-24 version 2019a
- Hush some warnings issued in the GUI, plus several
  small GUI improvements
- Increase the default size of the script editor window
- dbnomics support: transition to using the v22 API
- Ban creation of named lists containing the semicolon
  separator, to ward off potential crashes
- "foreign" block with Julia: add --no-compile option
- "xtab" command: support TeX output and add some more
  formatting options
- "lad" command: add --no-vcv option
- SVM support: make this available on all platforms and
  drop the requirement of separately installed libsvm
- Fix bug: expansion of dataset via interpolation could
  fail under some conditions
- Fix bug: generation of random series via the GUI got
  broken
- Fix bug: "diff" command not always respecting a revised
  sample range
- Fix bug: the deseas() function stopped working when used
  with x12a/x13as

2018-12-21 version 2018d
- Internal representation of missing values: switch to
  using NaN
- Internal speed-ups for matrix reads and writes
- Add new function, atan2(), as per the C function of the
  same name
- Add new function isocountry(): maps between the various
  designations for countries (full name and codes) in the ISO
  3166 standard
- Add new function hyp2f1(): Gauss hypergeometric function
- Add new function brename(): rename a bundle member
- cdemean() function: add option to standardize in addition
  to centering
- boxcox() function: accept a matrix argument
- psdroot() function: add option to check for positive
  semidefinite status of matrix argument
- cdf() function: add support for logistic (code "lgt")
- "install" command: replace with new "pkg" command (but the
  old form still works until further notice)
- "levinlin" command: add a --verbose option and fix some
  bugs
- "arima" command with --x-12-arima option: enable the $vcv
  accessor
- "dpanel" command: add --keep-extra option to enable access
  to the GMM weights and instrument matrices after estimation
- Native arima: improve the scaling of dependent series
  when necessary
- Line plots via gnuplot: show gaps for missing values
- dbnomics: some refinements to handle problematic cases
  as well as some new functionality
- Matrix power (A^k): support fractional and negative powers
  for positive-definite matrices
- Fix bug: out-of-bounds writes to matrices were not being
  caught under all conditions
- Fix bug: giving an all-zero initializer to "arima" could
  result in a crash
- Fix bug: the $ylist accessor was giving the wrong series
  ID in the case of "arima"
- Fix bug: VECM forecast failing in some cases
- Fix bug: panel plot, boxplots by group, was failing when the
  sample range begins at a positive offset
- Fix bug: "bundle-plot" mechanism for function packages in
  the GUI broken after the first invocation
- "mle": drop the requirement that a dataset is in place
- "foreign": support the changes in Julia version 1.0
- Windows: improve handling of non-ASCII filenames, including
  names not representable in the 8-bit code page
- Windows and Mac packages: update to gmp 6.1.2, mpfr 4.0.1

2018-09-03 version 2018c
- Fix bug: the panel-statistic functions pmean() and psd()
  give wrong results when only the first observation of a
  cross-sectional unit differs from the others
- "foreign" support for R: try to handle non-ASCII filenames
  in the gretl.loadmat function
- Prevent crash on failure to access a single dbnomics series
- Correct index shown in an "out-of-bounds" error message
- Correct alignment in printing "note" for bundle member
- Support indexing into a list-member series (e.g. "L[i][t]")
- Read Ctrl-G as "Find again" in find dialog box, and make
  search wrap silently
- Matrix "division": handle the reduced-rank case properly

2018-08-11 version 2018b
- New feature: support for data access via dbnomics
- New feature: the GUI console now uses syntax highlighting
- Revised feature: the descriptive "labels" for series can
  now be of arbitrary length
- Substantial speed-up of AR(I)MA estimation, using
  Melard's algorithm AS 197; also improvements to the
  initialization for such estimation
- New option --name for the "data" command: rename a series
  on importation
- New option --tree for "print": show content of bundles
  recursively
- New function jsongetb(): construct a bundle mirroring the
  content of a JSON tree
- New function lrcovar(): long-run covariance
- New function fevd(): forecast error variance decomposition
  following estimation via "var" or "vecm"
- New accessor $system (bundle) following estimation of a
  system of equations
- Enhancements for nadarwat() function
- When R_functions is set "on", accept call to an R function
  without assignment of the return value, if any
- Fixes for GUI model specification dialog: breakage in
  selection of GARCH robust variance estimator variant,
  and non-availability of lag selection in some cases
  where it should be available
- Fix bug: "omit" command not working for dynamic panel
  models
- Fix bug: saved argument lists for function packages
  getting out of sync with the user-selected interface
- Fix bug: command-line refinements for the "graphpg"
  command subject to bitrot
- Fix bug: crash on Windows when using Tab key in the data
  editor window
- Fix bug: crash in "modprint" under some conditions
- Fix bug: potential crash in Stata (dta) importer under
  some conditions
- Fix bug: wrong handling of intra-sample missing values
  with "pca" command
- Fix bug: files written by third-party programs under
  gretl's "foreign" could end up not visible to users
- Fix quasi-bug: failure on calling gnuplot when there's
  no variation on the x-axis
- Fix for Windows: support for filenames that cannot be
  represented correctly in the active code page
- Builds for Windows and Mac (Quartz): update to gnuplot
  5.2.4

2018-03-17 version 2018a
- New function instring(): boolean variant of strstr()
- "join" command: add --aggr=spread option for importing
  high frequency data for use in MIDAS analysis
- strsplit() function: add optional third argument to choose
  the separator on which to split strings
- mreverse() function: make this work for a list argument
- hpfilt() function: add option of one-sided filter
- svm() function: better handling of missing values, and add
  support for probability estimation
- cdf() function and friends: add support for Laplace
  distribution
- R-function support: handle string arguments
- rename some functions: colnames becomes cnameset, rownames
  becomes rnameset, and colname becomes cnameget; the old
  names still work as aliases
- New function rnameget(), strictly analogous to cnameget()
- Fix bug: setting of a series as "discrete" via the GUI got
  broken
- Fix bug: the --www option for opening a database file got
  broken
- Error messages from X13-ARIMA: try to relay these to the
  user more effectively
- "arima" command: big speed-up for exact ML estimation of
  specifications without an AR component
- "heckit" command: add selection equation regressor list to
  $model bundle under the key "zlist"
- "xtab" command: add --quiet option and enable accessors
  $test and $pvalue for the Pearson chi-square test in the
  bivariate case
- "difftest" command: add --quiet option
- "smpl" command: add --quiet option
- "foreign" command, python interface: add support for fast
  data transfer via binary matrix files
- CSV data reader: support date format YYYY-Qq for quarterly
  data
- Kalman filter documentation: add an example, one-sided
  Hodrick-Prescott filter in the manner of Stock and Watson
- GUI: tabbed script editor option: make this the default
- GUI convenience: add facility to generate 100-based indices
  of selected series
- GUI plot editor: support selection of dash patterns for
  plots using lines
- GUI file chooser for "Open data": remember the last chosen
  file type and set the filter accordingly
- Build fix: correct undefined symbol in cephes/iv.c
- Boxplots: fix for incorrect extent of "whiskers" in some
  cases
- Boxplots: fix for "collapse" of boxplot when edited in
  the GUI, if the locale decimal separator is ','
- GUI fix: the iterate option for groupwise weighted least
  squares (Model/Panel menu) had become disconnected
- GUI fix: plot with confidence band could go wrong in the
  presence of missing values
- Windows fix: error on trying to save a record of executed
  commands on program exit
- Several refinements for configuring and building gretl on
  MS Windows
- Windows packages: update to gtk 2.24.32
- OS X fix: intra-program drag-and-drop provoked crash
- translations: add simplified Chinese

2017-11-07 version 2017d
- New accessor, $tmax: gives the maximum legal setting for
  the end of the sample range via "smpl"
- $model bundle: add members t1 and t2 (start and end of
  estimation range)
- New function getinfo(): returns a bundle with information
  on a specified series
- New function cdummify(): applies to a list, with the effect
  of "dummifying" any and all series in the list that have
  the "coded" attribute set
- New function numhess() to compute numerical Hessian; also
  improve accuracy of the underlying numerical_hessian code
- "pca" command and princomp() function: center but do not
  standardize when computing principal components using the
  covariance matrix
- "midasreg" command, mds() term: allow specification of min
  and max lags via scalar variables
- psdroot() function: use improved algorithm (from Golub and
  Van Loan)
- fdjac() function: add (optional) trailing argument to set
  step size
- randgen() function (and related): add support for the
  Exponential distribution
- CSV importation: improved handling of quote symbols
- Fix bug: incorrect standard errors when the --robust option
  is given for random-effects panel estimator in presence
  of missing values
- Fix bug: rename() function not working on Windows when
  the target filename already exists
- Fix Windows-specific bug: long strings could get "lost" in
  printf and sprintf
- Fix bug: on repeated estimation of a given arima model in
  a function one might get slightly different results
- Fix for Windows XP: produce a build of gnuplot that does
  not depend on API introduced in later Windows versions
- Fix for Mac: try to ensure the default font is not too big
  when printing a script
- Fix for text search on Windows: try to ensure the found
  text is actually scrolled into view
- GUI: enable a tabbed editor for foreign scripts
- GUI: fix breakage in function-package search facility
- GUI: fix crash on requesting "Numerical summary" for panel
  groups boxplot
- GUI: fix for GUI editing of MIDAS plots
- GUI: improve font-selection dialogs, including a "Reset to
  default" option
- GUI: don't show duplicates in the database browser window;
  in case of duplicates just show the newest version
- Build process: enable use of "configure ; make" when
  building gretl on Windows using MSYS2
- Experimental: add support for machine learning via SVM:
  http://ricardo.ecn.wfu.edu/pub/gretl/svm/gretl-svm.pdf

2017-07-18 version 2017c
- MIDAS support: several small fixes and refinements
- "panel" command: add an --unbalanced option to inflect
  random effects estimation for unbalanced panels
- Extend the $ahat accessor to support retrieval of the
  individual effects from random effects panel data models
- Rename the $fcerr accessor as $fcse (but keep $fcerr as an
  alias)
- Creation of lists: support '?' as wildcard standing for a
  single character
- GUI: add "Packages" item under the Help menu: basic info on
  Addons and contributed function packages
- GUI: add an easy way to scale both the menu font and the
  monospaced font for formatted output
- GUI: move the file-related function-package items from
  the Tools menu to the File menu
- GUI: move the Preferences submenu to the top of the Tools
  menu
- GUI: increase the default size of the main window somewhat
- GUI: forecast window, add button: enable saving of forecast
  standard errors when available
- GUI: add display of name of working directory
- GUI editor for "foreign" scripts: some usability enhance-
  ments
- library: add some internal functions to support operations
  on complex matrices using LAPACK
- library: add functionality to make use of an mpi block
  from a function package as seamless as possible
- Fix buglet re. text coloring in script output window
- Tweak naming of auto-generated list for midasreg in the
  GUI program
- Fix bug: failure on repeated assignment of a constant
  string under a bundle key in a loop
- Fix bug: "Up to date" indicator for function packages got
  broken
- Fix bug: "boxplot" command with matrix argument: should
  default to plotting all columns
- Fix bug: nested calls to a given function were failing in
  cases where the inner call occurred at the second or higher
  argument slot
- Fix bug: the seq() function not producing correct output with
  decreasing arguments
- Fix bug: crash when viewing forecasts with confidence
  intervals under Russian translation
- MS Windows: upgrade to mkstemp() for tmp file creation (was
  missing from mingw)

2017-05-26 version 2017b
- "gnuplot" and "plot" commands: support --font option for
   PDF, EPS and EMF output
- "rename" command: add a --quiet option
- "arma" command: support --robust (QML) option
- "mle" command: support the --cluster robust option
- "midasreg" command: several fixes and enhancements
- "modprint" command: accept an array of strings as the
  "names" argument
- Allow adding lists as such to bundles
- fcstats() function: expand the accepted set of arguments
  (mix series and vectors, handle multiple forecasts)
- New function deflist() for defining a list (of named
  series)
- New function defbundle() for initializing a bundle
- New function xmlget() for extracting data from an XML
  buffer (similar to jsonget)
- New function smplspan() to determine the number of
  observations within a specified time-series range
- New function GSSmax(): one-dimensional maximization via
  Golden Section search
- GUI: revamp Time series model menu and ARIMA specification
  dialog
- Fix bug: some operations that check status of a model's
  list of regressors failing inside functions, or when a
  model was estimated with no printed output
- Fix bug: ensure that the $model accessor (bundle) is
  available to function packages that attach to a model
  window
- Fix bug: breakage in column headings for the printout of
  multinomial outcome probabilities in GUI
- Fix bug: "catch" failing in loops under certain conditions
- Fix bug: plot with the --band option could fail in locales
  that use the decimal comma
- Validate $-bundles as legitimate function arguments

2017-04-15 version 2017a
- Improved parsing for the member-of relation, on both
  the left- and right-hand side of hansl statements
- Calendar: ensure that the Gregorian calendar is used
  consistently but add some optional support for handling
  Julian dates (also add a User's Guide chapter on this)
- xls, xlsx, ods and gnumeric data importers: handle string
  data (this facility extended from the CSV importer)
- Remove obsolete Kalman-filter interface
- Sequential numbering of models: skip models estimated
  with the --quiet flag and also those estimated within
  functions
- Deprecate "=" as obsolete synonym for boolean "=="
- New functions kmeier() and naalen() for nonparametric
  estimation of survivor and hazard functions
- Add normtest() function: works much like the "normtest"
  command, but handles vectors as well as series
- Add ecdf() function to compute the empirical CDF for a
  series or vector
- New function npcorr() for nonparametric correlation,
  either Kendall's tau or Spearman's rho
- bwrite() function for writing bundles as XML: support
  gzip compression if the filename has the ".gz" extension
- typeof() function: document it, and extend it to cover
  members of bundles and arrays
- "include" command: make it respect the "catch" flag, and
  add a --force option to force re-reading of gfn files
- "corr" command: add a --plot=filename option; also add
  --matrix option to take data from a named matrix
- "gnuplot" and "plot" commands: add a --font option
- "fcast" command: in the case of the --rolling option,
  accept the name of a scalar variable for the steps-ahead
  argument; also respect the last observation specification
  in all cases
- "tsls" command: calculate Sargan test in overidentified
  case even when there are no endogenous regressors, to allow
  "difference in Sargan" test
- "modtest" command with --autocorr or --arch option, as
  applied to VAR/VECM: switch from per-equation tests to
  multivariate tests as described in Lutkepohl's 2005 book,
  but add a --univariate option to give per-equation tests
- "var" and "vecm": enable the --window (-w) option to show
  results in a window from script execution
- "hausman" command: add options --nerlove and --matrix-diff
  to inflect the random effects estimator and calculation
  of the Hausman test statistic
- Principal Components window in GUI: support selection of
  a specific number of components to save as series
- ARMA models in GUI: add menu item to view plot of spectrum
  versus sample periodogram
- Fix bug: functions failing to return loop-index value
- Fix bug: couldn't assign to an array member of a bundle
- Fix bug: multiple X-Y scatterplots could fail when using
  long variable names
- Fix bug: the matrix-oriented version of the "restrict"
  command would fail when only the constant was restricted
- Fix bug: reading of gzipped matrix files via mread() was
  much slower than necessary for large matrices
- Fix bug: couldn't read .mat (matrix) files generated by R
  on Windows when they contained NaN values
- Fix bug: closing the function package browser while a
  package is running could cause a crash
- Fix bug: possibly misaligned labels when doing a group-
  means scatterplot using panel data
- Fix bug: "outfile" command with --buffer option was
  failing on MS Windows
- Update documentation for inlist() function
- Update translated Command Reference PDF files for Italian
  and Portuguese
- Add Galician (Galego) translation of the online Function
  Reference
- User's Guide: add a chapter on degrees of freedom
  correction for standard errors and related statistics
- Build for Mac OS X: update the bundled GTK stack
- Builds for MS Windows: update compiler to gcc 5.4.0

2016-11-19 version 2016d
- New commands to support MIDAS: "midasreg" and "hfplot"
- New MIDAS-related functions: hfdiff(), hfldiff(), hflags(),
  hflist(), mgradient(), mlincomb() and mweights()
- Add sample MIDAS datafile, gdp_midas.gdt, and accompanying
  illustrative script, gdp_midas.inp
- New function BFGSmaxc() for constrained maximization using
  L-BFGS-B, version 3.0
- New maximization function NMmax() (Nelder-Mead "amoeba")
- New function cnumber() to get Belsley's condition number
- Small fixes for --compact=spread and new lags() options
- "qlrtest" command: enable --quiet option
- "nls" command: make --verbose output more informative
- "modtest" command: add --xdepend option for Pesaran's CD
  test of cross-sectional dependence in panel-data models
- "gnuplot" and "plot": add "bars" option for plotting a
  confidence band with error bars
- "pca" command: restore facility to skip missing observations
  rather than flagging an error
- "fcast" command: add a --stats-only option to print the
  forecast evaluation statistics without the actual forecasts
- "outfile" command: add a --buffer option to divert output
  to a string variable
- median() function: accept a list argument, as with mean()
- GUI main window popup menu: add option to check for
  collinearity when two or more series are selected
- GUI function package browser: add last-modified date to
  the information shown; remove option to edit packages
- The option of using the Box-Muller method for generating
  random normals is now removed
- The Mersenne Twister code is updated to SFMT 1.4.1, and the
  generation of random normals is speeded up
- Add and document a $model accessor which retrieves a bundle
  containing information regarding a single-equation model
- Matrix manipulation syntax: allow use of negative indices to
  drop specified rows/columns
- Fix an issue where gretl might fail to read back a gdt data
  file written by itself
- Fix for sort() and dsort() as applied to row or column
  vectors: if row or column names are present, keep them
  aligned with the original values
- Fix breakage in "dataset renumber" command
- Fix breakage in "modtest" command with --white option
- gig addon: fix an off-by-one bug
- Fix bug: potential crash in GUI filter plot with very long
  series name
- Fix bug: non-interactive calling of R from gretl on Windows
  got broken somehow
- Fix: return 1 rather than NA for chi-square p-value in case
  of underflow
- Fix bug in mcorr() function: correlations between constants
  should be NaNs, not zeros
- Fix bug: potential crash with the "delete" command on a
  list which contains duplicated series
- Installers for Windows, Mac: include fuller set of PDF docs
- MS Windows builds: update to gtk-2.24.30, update libffi

2016-07-06 version 2016c
- Add Ukrainian translation
- Major revision of the user interface to the Kalman filter
  and state space modeling
- New function dropcoll() to expunge collinear terms from a
  list of series
- lags() function: accept a vector for the first argument
- New variable under the "set" command: "force_qr" forces
  the use of QR decomposition in the "ols" command
- Add new --band option to the "gnuplot" and "plot" commands,
  for plotting confidence bands and the like
- "gmm", "mle" and "nls" commands: document the previously
  hidden "param_names" keyword
- "nls" command: add --no-gradient-check option, as in "mle"
- "append" command: add --fixed-sample option: restricts the
  operation to "sideways" appending of new series
- "data" command, --compact option: add new mode, "spread"
- Writing and reading files via commands and functions: ensure
  that the gretl "working directory" is respected if an
  absolute path is not given
- Fix spurious "no numeric conversion" message emitted by
  some plot editing operations
- Lags button for exogenous variables in VARs: ensure it's
  sensitive when it's supposed to be
- Add Nile flow dataset to the package, plus a sample script
  that estimates the Local Level model
- Function package DTD: make "tags" element mandatory; plus
  add offline tags list to GUI package editor
- Fix bug: crash on malformed "genr" expression with only a
  type name
- Fix bug: crash with the "mpols" command when the dependent
  variable is a constant
- Fix bug: gnuplot error on selecting "loess fit" via the
  GUI plot editor when the plot already has a fitted line
- Fix bug: the transpose-multiply operator (') now respects
  right-associativity
- gig: add variance forecasting (only residual-based for APARCH
  so far)
- Miscellaneous smaller bug fixes

2016-04-14 version 2016b
- "panel" command, random-effects version: show an overall
  Wald chi-square test on the named regressors; also support
  the --robust option
- "dataset" command: expose and document the "pad-daily"
  option
- "vecm" command: clarify the options available when specify-
  ing a restriction on beta via matrices R and q
- Commands that produce both textual output and plots: add
  a --plot option to control the format of the plot
- GUI help text: make references to the Gretl User's Guide
  chapter-specific, and make the file open at the specified
  chapter if the PDF viewer supports that functionality
- GUI "view code" option for function packages: avoid slow
  loading of big code buffers
- GUI plot editor: enable selection of point size for graph
  styles that use points
- Internal code: introduce several optimizations to speed up
  execution of complex scripts
- "foreign" language mechanism: add basic support for Julia
  (including editing and execution of Julia programs)
- build: try harder to respect --disable-nls (though this is
  very difficult nowadays)
- Fix bug: crash on performing some matrix transformations
  using the GUI "icon view"
- Fix bug: broken format in output of actual versus forecast
  values in some cases
- Fix bug: CSV import failing in locales that use decimal
  comma when file uses decimal comma and also '.' as thousands
  marker
- Fix bug: handling of "missingness" in imported daily data
  not working quite right
- Fix bug: "omit" command with --auto option failing for
  ordered logit/probit models
- Fix bug: potential crash in printing the results of a
  random-effects probit model with small RE variance
- Fix bug: GUI access to nonparametric models was broken
- Fix bug: not flagging an error when given a broken right-
  hand side specification in the "restrict" command
- Fix bug: matrix-form restrictions on VECM model not being
  accepted even when valid, in some cases
- Fix bug: partial parsing of command line when blocked by a
  false if-condition could give rise to spurious errors
- Fix bugs: some subtle fail conditions for saving compiled
  loops onto functions
- OS X (quartz) build: update to GTK 2.24.29, and fix a GTK
  issue which led to crashes on OS X 10.11 (El Capitan)
- OS X (quartz) build: fix problem with gnuplot wxt window,
  add Adwaita theme, and make Adwaita the default
- Bundled gnuplot for Windows and OS X: update to 5.1 cvs as
  of March 2016
- MS Windows builds: update to OpenBLAS 0.2.18dev.

2016-01-26 version 2016a
- syntax enhancement: allow specification of type when setting
  a bundle member
- syntax enhancement: allow specification of a null default
  value for a matrix argument to a user-defined function
- script execution: save "compiled" loops in functions that
  are called repeatedly, for greater efficiency
- add exists() function, recommended as a replacement for the
  now-deprecated isnull()
- add pxnobs() function: gives the number of valid cross-
  sectional observations on a given series in each period
- pxsum() function: revise this to skip missing values
- the gretl array type: document the array() and defarray()
  functions
- "arima" command: allow ARIMA(0,1,0) without constant
- "heckit" command: allow clustered standard errors
- "reset" command: add --silent option
- "store" command and GUI "Export data" menu item: add option
  to save data in Stata's binary format (dta version 113)
- "funcerr" keyword: allow use of a string variable to provide
  the message to be printed
- Improve handling of string-valued series across sub-sampling
- Improve display of string-valued series in GUI
- seasonals() function: enable this for panel data when a
  suitable imterpretation of the time dimension has been set
  via "setobs"
- Fix bug 196, Help button for HCCME misaligned in case of a
  non-MPI enabled build
- Fix bug 197, invalid "xtics" specification for some weekly
  time-series plots caused gnuplot to abort
- Fix bug: failing to detect common "missing value" strings in
  spreadsheet data importation via the GUI
- Fix for linearize() function: don't fail when tramo finds
  that the input doesn't need linearizing
- Fix bug: incorrectly sized object in ODBC data importation
  could cause a crash
- Fix bug: possible crash on importing data from a Stata dta
  file on 32-bit Windows
- Fix bug: in "hsk" the auxiliary regression should always
  include a constant, even if the base specification doesn't
- Fix bug: South-East element of intreg Hessian was buggy
  (was affecting Tobit as well)
- Fix bug: in GUI setting of dataset structure, the interpret-
  ation of stacked cross-section panel data was incorrect
- Application of "catch" to user-defined functions: drop back
  from an error to a warning, for now
- Appending daily data: don't fail when we have enough date
  information to succeed
- Improve handling of EPS plot output (including respecting
  the color/mono choice properly)
- Stata dta importer: support dta format 118 (Stata 14)
- GUI: some cosmetic fixes specific to gtk 3
- GUI script editor: implement choice of gtksourceview style
- GUI function package editor: ensure that old-style "minimum
  version" specification is read correctly; also ensure that
  appropriate line-breaks are set by the help-text editor
- MS Windows package: update to OpenBLAS 0.2.16.dev to avoid
  bug in computing eigenvalues on 64-bit Windows
- Add workaround to avoid OpenBLAS crash on matrix inversion
  when the input matrix contains NaNs
- Remove support for gnuplot < version 4.6.0

2015-10-19 version 2015d
- add varnames() function: similar to varname() but returns
  an array of strings given a list argument
- movavg() function: add option to supply a specific
  initializer for the exponential moving average; also
  enhance the corresponding GUI
- "setobs" command: provide more flexible means of setting
  panel group names when using the --panel-groups option
- "tabprint" and "eqnprint" commands: deprecate the syntax
  "-f filename" in favor of --output=filename
- "modtest" command: respect the --quiet and --silent options
  when the test is on a multi-equation model
- Document some undocumented accessor variables
- Make some error messages more specific and explicit
- Add new Function Package Guide to Help menu
- Data-editing spreadsheet: improve formatting of values
- GUI function package editor: further fixes and enhancements
- SVAR: implement Kilian's bias correction procedure properly
- Fix bug: possible data corruption on reading a gdt file
  containing subnormal values
- Fix bug: using options with the "data" command was broken
  in the GUI program

2015-09-13 version 1.10.2 (2015c)
- "install" command: add a --local option plus the ability
  to install a package from a chosen server
- "chow" command: represent the --limit-to option in the GUI
- "corrgm" command: add --bartlett option to use Bartlett
  standard errors for the ACF
- "hsk" command: add --no-squares option to emulate the
  variant of this procedure favored by Wooldridge
- "vif" command: upgrade to show Belsley-Kuh-Welsch variance
  decomposition for diagnosing collinearity
- "panel" command, fixed-effects variant: when the --robust
  option is given, substitute robust joint tests on both the
  regressors and the fixed effects
- cdf(), pdf() and invcdf() functions: add support for non-
  central variants of the chi-square, F and Student's t
  distributions
- Add new function square(): returns list of squares of its
  list argument, with the option of also generating cross-
  products
- Add new function seasonals() for "smart" generation of
  seasonal dummies, with the option of centering the dummies
- Add function pexpand() for creating a non-time varying
  panel series from a vector
- Matrix comparison: add ".!=" operator to test for element-
  wise inequality
- TRAMO interface: allow saving of "linearized" series
- Add new accessor $lang to get national language identifier
- Add Romanian translation
- Random effects probit: parallelize quadrature code
- GUI: numerous improvements and fixes for editing and
  configuring function packages
- Fix bug: the wrong F-test was being reported for the fixed
  effects estimator with the --robust option
- Fix bug: possible hang of "foreign" on Windows when using
  Rterm non-interactively
- Fix bug: bwrite() not completing until gretl exits
- Fix bug: matrix transpose (') not accepted before the colon
  of the ternary query operator
- Fix bug: model sample information not being updated when a
  sample restriction is applied with the --permanent option
- Fix bug: optional arguments to bkfilt() function not being
  recognized properly
- Fix bug: urcpval() might not update its argument when
  called inside a loop
- Fix bug: assigning "null" to a new array was not working
- Fix bug: crash when "tabprint" is used without a filename
- Fix bug: TRAMO options not always getting set as per the
  user's selection via the GUI
- Fix bug: normality test for system residuals not hooked
  up for non-time series models
- Fix bug: "open" with --odbc option not working
- MacKinnon urc p-values: much faster calculation
- MS Windows build: add option of using Clearlooks theme;
  add a new build of libcurl with SSL enabled
- OS X (quartz) build: update the packaged gnuplot build and
  add support for the "wxt" terminal

2015-04-04 version 1.10.1 (2015b)
- Fix bug: breakage in ADF test: giving more than one
  deterministics option with the "adf" command (in its basic
  form) should not provoke an error

2015-04-02 version 1.10.0 (2015a)
- Replace old command-line parser with new, faster "tokenizer"
- Add "install" command to install function packages via the
  command line
- Add "plot" command, a streamlined version of the "gnuplot"
  command
- "chow" and "qlrtest" commands: add --limit-to option to
  restrict the break test to a subset of regressors
- "qlrtest": add new accessor $qlrbreak
- Add new function qlrpval(): gives Bruce Hansen's asymptotic
  p-values for QLR sup-Wald test
- GUI command log: make the log window more accessible, and
  make it refresh automatically
- GUI design: standardize the position of the window list
  button (top right), and make it more functional
- GUI, panel data: some improvements to plotting options
- GUI, script editor: add support for Stata scripts
- GUI, model table: support tsls models; also remember format
  preferences across gretl sessions
- "join" command: support native data files (gdt, gdtb) as well
  as delimited text files, for data importation; also support
  importing data from more than one series at a time
- "foreign" command: where the --send-data option is supported,
  add an optional list parameter to limit the exportation to
  a named list of series
- "data" command: fix incorrect importation of series with
  lower frequency than the current dataset; also add an
  --interpolate option for that context
- "set" command: add a new setter, "robust_z" to select
  asymptotic p-values when using the --robust option in
  estimation
- mwrite() and mread() functions: add facility to write and
  read matrices in binary format
- Stata dta importer: handle format 117 (Stata 13)
- CSV importer: add code to handle the case where data values
  are written with thousands separators
- KPSS test: use improved version of Sephton-type response
  surface to find critical values
- ADF test: don't try to use Ng-Perron modified AIC/BIC for
  lag-length selection when GLS pre-processing is not chosen;
  add option to use Perron-Qu lag-length selection
- Fix bug: GUI panel plot failed if the start of the sample
  range was advanced
- Fix bug: crash on attempting to open a file from the "Recent"
  list within the GTK file chooser
- Fix bug: user-defined plots could generate an error dialog
  even if they display OK
- Fix bug: crash on reading gdtb (binary) data file containing
  observation markers
- Fix bug: crash on using "omit" with a duration model
- Fix bug: crash on trying to compact hourly data
- Fix bug: copy-and-paste produced raw RTF mark-up in some
  cases on MS Windows
- Builds for Windows: update cross-compiler to gcc 4.8.4;
  update to OpenBLAS 2.13; replace Netlib reference lapack and
  blas with OpenBLAS in 32-bit build; update to GTK 2.24.27;
  update to gnuplot 5.1 (CVS)
- Mac quartz build: update to GTK 2.24.25

2014-09-20 version 1.9.92 (2014c)
- Add new functions: isdiscrete(), isdummy()
- Enable faster execution of assignment statements in loops
- Add and document function-form of "sprintf"
- Fix bug: correct the procedure for recoloring following
  prewhitening in the context of the Newey-West HAC estimator
- Fix bug: "omit" would not print full estimates in a loop
- Fix bug: crash when using "Edit/modify model" in GUI for a
  biprobit model
- Fix bug: "catch" for genr in loops not always setting $error
  value on error
- Fix bug: incorrect behavior of randgen() for uniform values
  when the given lower bound is negative
- "append" command: add option --update-overlap
- "data" command: use --compact option in place of ad hoc
  "(compact=method)" syntax
- MS Windows: improve handling of non-ASCII text in RTF output
  and when putting data on the clipboard

2014-07-28 version 1.9.91 (2014b)
- Add Japanese translation (thanks to Shintaro Nakagawa)
- Add new functions: curl(), jsonget(), nlines(), kpsscrit(),
  genseries()
- Add new command "setopt" for pre-setting of command options
- Add command "flush" for use with time-consuming scripts and
  hansl functions
- "smpl" command: add a --permanent option to make a sample
  restriction permanent (not undoable); also add an option
  --no-all-missing to complement --no-missing
- "data" command: support globbing for names of series to fetch
  from gretl native databases
- "ar1" estimation: better error message(s) on failure; also
  tighten the convergence criterion but add a --loose option
  for backward compatibility
- "modtest" and "coint" commands: add --silent option for each
- Importing "CSV" etc: handle UTF-16 and UTF-32 by recoding, if
  recognized via Byte Order Mark
- ghk() function: add an optional trailing argument to receive
  the derivatives of the multivariate probabilities
- weekday() function: generalize to accept series arguments
- kdensity() function: accept a vector argument
- When creating a matrix from {list} or {dataset}, add the
  names of the variables as column names
- Difference of means test: use Satterthwaite approximation if
  the two variances are not assumed to be equal
- $dwpval: return NA rather than flagging an error if we get a
  negative Imhof integral (and adjust the doc)
- GUI dataset structure "wizard": allow annual data to start in
  the year 1
- Fix bug: GUI crash when estimation of rho fails for ar1 model
- Fixes for the XLS importer including recognition of the Excel
  NA() function
- Fix broken encoding of German translation
- Fix bug in OS X (quartz) package: GDK could lose track of its
  PNG loader, so graphs would not display
- Hush some gcc-4.9.0 warnings
- Deprecate use of the "set" variable halt_on_error (and remove
  its documentation)
- Build: update config.guess and config.sub from autotools git
- Windows build: update to gtk 2.24.24; update gnuplot version
  to 4.6.6

2014-05-02 version 1.9.90 (2014a)
- GUI reorganization: move the Function packages menu from
  /Files to /Tools
- GUI enhancement: add News button under "/Help/About gretl"
  to display list of changes in the current version
- Help menu: add item for the new "hansl primer" which covers
  the basics of gretl's scripting language
- Introduce a new native binary datafile format, the gdtb file
  (zipped XML metadata plus binary values)
- Add new functions: bread(), bwrite(), substr(), easterday()
- "summary" command: add --weights option
- "tabprint" command: add --csv option
- fdjac function: provide choice of algorithm
- Enable use of arrays in the SFMT random number generator
- Enable use of value labels (if any) in factorized boxplots
- Enable use of named lists in the GMM() and GMMlevel()
  parameter-groups for the "dpanel" and "arbond" commands
- Print out alternative definition of R^2 in FE linear panel
  data models
- Add choice of compression level when saving data in native
  gdt format
- Stata dta import: handle (illegal!) non-ASCII characters in
  variable names
- X-12-ARIMA interface: support the new X-13-ARIMA-SEATS as an
  alternative
- Fix bug: incorrect plot header when the --radians option was
  given with the "pergm" command
- Fix bug: the --test-down option to "coint" was not working
  as advertised
- Fix bug (?): the final regression in "coint" (Engle-Granger
  test) could end up using a different sample range depending
  on whether or not the --skip-df option was given
- Fix bug: incorrect handling of Poisson regression when the
  specification does not include an intercept term
- Fix bug: bad handing of decimal comma in context of the --by
  option
- Fix bug: incorrect treatment of big-endian SPSS "sav" files
  on data import
- Fix bug: the auxiliary regression for White's test should
  contain a constant even if the model to be tested does not
- Fix bug: wrong starting date being sent to x12a/x13as for
  monthly data starting in October
- Fix bug: score calculation for random-effects probit was
  incorrect
- Fix bug: incorrect estimates when the --robust option was
  used with the "wls" command
- Fix bugs 181, 182
- Internals: add support for multiple, independent PRNGs
- configure script: add an option --disable-www which drops
  the libcurl dependency, conditional on not building the
  GUI program
- win32 build: update gmp to 5.1.3, mpfr to 3.1.2

2013-11-21 version 1.9.14 (2013c)
- Use daily dates when plotting daily/weekly data and there
  are not too many observations
- Line-numbering in the script editor: make this a preference
  which is remembered
- mols() function: parallelize some of the work for builds
  with openmp enabled
- GUI: provide a menu item for adding a panel unit index
- GUI: "/File/Save data as" now switches the current dataset
  to the name of the saved one
- Fix bug: the build of gnuplot included in the gretl-quartz
  package (for Mac) did not work properly in stand-alone mode
- Fix bug: the importer for SAS "xport" files over-counted the
  number of observations, leading to out-of-memory failure on
  very big datasets
- Fix bug: the --show-plot option to the "freq" command was not
  being respected
- Fix bug: failure parsing value-labels for "int" arguments in
  building function packages
- Fix bug: "foreach" loop failing when given a single term that
  is not a named list
- Fix bug: panel Hausman test producing bad output under some
  conditions

2013-10-24 version 1.9.13 (2013b)
- Add Bulgarian, Catalan and Galician translations
- Add new functions: psum(), prodc(), prodr(), toupper(),
  getline(), isodate(), regsub(), atof()
- "adf" command: add option to optimize the lag order using
  the procedure recommended by Ng and Perron (2001), and
  make their modified AIC method the default
- "outfile" command: add --quiet option
- "var" command: add syntax to select specific lags
- "boxplot" command: add facility to specify literal gnuplot
  lines, as with the "gnuplot" command
- "setobs" command: add panel-specific options to set panel
  time characteristics and group names
- "join" command: substantial enhancements for dealing with
  realtime data
- Make it legal to set loop_maxiter to 0 (hence disabling
  the safety iteration limit for "while" loops)
- Improve internals of pprintf() -- handle big string args
  properly
- readfile() function: check for valid UTF-8 and recode if
  possible if the text is not UTF-8
- mwrite() and mread() functions: add support for gzip
  compression
- setnote() function: add an entry to the function reference
- mshape() function: allow scalar as first argument
- filter() function: allow matrix as first argument
- GUI: add stacked-bar option for FEVD plot in connection
  with VAR estimation
- Fix a few small GUI memory leaks
- Linux and Windows: add check for multiple instances of
  gretl, and choice to open a double-clicked file in the
  prior gretl instance, if any
- Fix bug: encoding problem when printing from model window
  on Windows
- Fix bug: "catch" not working properly when applied to
  genr expressions within loops, and also for multi-line
  commands in loops
- Fix bug: bad behavior when taking the transpose of a
  scalar variable in a loop
- Fix bug: daily dates in old format YYYY/MM/DD not handled
  correctly in the context of time-series plots
- Fix bug: incomplete error-detection when parsing calls to
  diff() and log() on model-specification command line
- Fix bug: $obsminor and $obsmicro not working with weekly
  datasets
- Fix bug: matrix re-import from octave was broken
- Fix bug: functions such as obsnum() which expect a string
  argument were failing when the argument was given in the form
  of a function that returns a string
- Fix bug: when python code is embedded in a gretl "foreign"
  block within a user-defined function, indentation of the
  python code was not being respected
- Fix bug: in the context of the ternary query operator (as in
  "condition ? true_branch : false_branch") the presence of an
  undefined symbol was generating an error even if this symbol
  was confined to the non-selected branch
- Fix bug: the "modeltab" command with the --output=filename
  option was not working properly unless "modeltab show" was
  executed first
- Stata .dta importer: read Stata 12 data files
- xlsx importer: handle "inline" strings
- CSV importer: ignore leading byte order mark
- MS Windows: add a 64-bit build of gretl as a download option
- OS X: add a 64-bit gtk-quartz build of the gretl package

2013-03-15 version 1.9.12 (2013a)
- Officially increase the maximum length of variable names
  to 31 characters
- "foreign" command: add support for Python + NumPy
- "markers" command: add support for the panel-data case
  where the number of markers equals the number of cross-
  sectional units
- "delete" command: add option to delete all variables of a
  specified type
- "qlrtest" command: compute asymptotic p-value as per Bruce
  Hansen's method (1997)
- "modeltab" command: add --output option to direct the model
  table to a specified file
- $xlist accessor: make available for system estimators
- You can now use "bundle b = null" to create a new bundle or
  empty an existing one
- Enable more streamlined syntax for setting and accessing
  objects within bundles, as in bundle.member
- Add new string function strstrip()
- Add new data-manipulation function aggregate()
- Add new function quadtable(), for Gauss quadrature
- Add new function remove(), for file deletion
- lags() function: add an optional third parameter to control
  the ordering of terms in the output list
- mread() and mwrite() functions: add an optional argument to
  direct read/write to the user's "dot directory"
- Add accessors $obsmajor and $obsminor to get series holding
  (for example) year and month; also $obsmicro for daily data
- Improve structural integrity of model specification dialog
  (it now behaves properly on resizing)
- Gnuplot version: require 4.4.0 (March 2010) or higher
- GUI preferences dialog: add facility to set the default scale
  for PNG plots
- GUI Tools menu: add an item to launch an interactive gnuplot
  session
- GUI Add menu: add support for auto-generated dummy variables
  that code for a specific range of observations (or a single
  observation)
- Fix bug: transient objects created within functions were
  appearing in the GUI icon view window
- Fix bug: possible crash when regressors are dropped from a
  random-effects panel model due to near-prefect collinearity
- Fix bug: possible crash in vecm with lag order 1 and no
  deterministic terms
- Fix bug: loss of precision when printing data to CSV file,
  in some cases
- User's Guide: clarify the use of string substitution, plus
  numerous small updates
- Environment: respect GRETL_CONFIG_FILE to override the
  default of ~/.gretl2rc on unix-type systems
- Daily dates: switch to ISO 8601 for output and preferred
  input (but accept YYYY/MM/DD for backward compatibility)
- MS Windows build: update GTK to version 2.24.17, and build
  with openmp support

2012-11-21 version 1.9.11 (2012d)
- Substantial re-write of code for handling named variables
  other than series (matrices, scalars, strings, etc.) in the
  interest of maintainability and efficiency
- "restrict" command: try to ensure that standard errors show
  as zero when they are in principle zero
- "loop": support use of $-substitution in the expression that
  controls a nested loop
- Fix bug: spurious detection of line continuation characters
  in #-style comments that do not start a command line
- Fix bug: broken printing of the model table in the case of
  variable names of greater than 15 characters
- Fix bug: "eval" not working correctly for anonymous strings
- Fix build bug: "make check" not working properly
- Fix build bug: XDG (desktop) files not getting installed in
  a manner suitable for packagers of gretl
- Support a matrix as an element-wise boolean condition for the
  ternary "?" operator
- The msortby() function: ensure that it performs a "stable"
  sort, such that rows sharing a common key value are never
  interchanged; also ensure that any row labels are put into
  the sorted order
- The inbundle() function: return a code that identifies the
  type of a bundled item; also add typestr() function to turn
  this code into a string
- GUI: allow resizing of plot windows, using the "+", "-" and
  "0" keys (depends on gnuplot's pngcairo driver)
- GUI: fix for "save as..." for session files on Windows
- GUI: fix for right-click in icon view window
- GUI: fix for font selector in the GTK 3 version of the code

2012-11-05 version 1.9.10 (2012c)
- Update translations
- Major new command "join": this adds sophisticated procedures for
  assembling a dataset from multiple sources
- New command "markers": manipulate observation marker strings
- "delete" command: add a --force option to permit deletion of
  series in loops (to be used with caution!)
- "data" command: allow this in loops
- "open" command: rename the option for reading fixed format data
  from --cols to --fixed-cols; also allow use of this command
  in loops (gretlcli only)
- "dpanel" and "arbond" commands: indicate in the model printout
  if the AR, Sargan or Wald tests failed
- "gnuplot" command: add a --with-lp option to use linespoints
- "modtest" command: support the autocorrelation option for ARMA
  models, using the Ljung-Box statistic
- "boxplot" command: add a --matrix option (works in the same way
  as with the "gnuplot" command)
- "freq" command: add a --matrix option to select a column from a
  named matrix instead of a series
- "corrgm" command: make the $test and $pvalue accessors available
  for the Ljung-Box test at the maximum lag
- "xtab" command: use string values of variables if available
- Add three new functions: ghk(), halton() and isnan()
- The mread() function now allows leading #-comment lines in the
  plain text file from which a matrix is read
- Add two new accessors: $pi and $huge
- Fix for ARMA forecasts: ensure that the dynamic portion starts
  as soon as possible when the --dynamic option is given
- Switch to using libcurl for HTTP transaction support
- Add two new element-wise matrix operators, ".>=" and ".<=",
  (greater than or equal, less than or equal)
- Fix some buggy behavior in regard to empty matrices
- Fix for use of "catch" (to trap errors) in loops
- Fix GUI bug: lagged series could become invisible in the main
  window under some (unusual) conditions
- Allow passing "null" as an argument for lists in user-defined
  functions
- Enable indexing into named lists to get the ID numbers of series
- Bivariate normal cdf: switch from Drezner(78) to a faster and
  more robust algorithm
- randgen() function, gamma distribution option: switch to the fast
  Marsaglia-Tsang generator for gamma variates
- GUI: add check for updated addons, such as gig
- GUI icon view: enable copying of graphs and matrices
- GUI graphs: in saving as PDF, remember the user's choice of font
  size for the duration of the session
- MS Windows build: work around problems associated with the
  "Virtual Store" folder-redirection introduced in Windows Vista
- Linux: add proper XDG support (mime types, icons)
- OS X package: update the gmp, mpfr and fftw libraries
- MS Windows and OS X: update gnuplot to version 4.6.1

2012-06-01 version 1.9.9 (2012b)
- Add --cluster option (cluster-robust standard errors) for several
  estimators; see the User's Guide for details
- Add (limited) support for Stata under the "foreign" command
- New accessor $ylist: returns the list of endogenous variables from
  the last system or model estimated
- "fcast" command: enable for multinomial logit models
- "store" command: respect sample range when exporting data to gretl
  database format
- "graphpg" command: enable printing from script
- Mark some more strings for translation
- Fix encoding for Polish translation
- Fix bug 3525304
- Fix bug: in logging commands entered via the gretl console, options
  were being omitted
- Fix behavior of Ctrl-A in non-editable text windows
- Fix breakage of GUI Alt-x command "minibuffer"
- "modtest" command with --normality option: make the accessors $test
  and $pvalue work when the test is done on a VAR
- Fix bug: arima initialization could interfere with formation of
  named lists
- Fix bug: nonlinearity test (logs) misbehaving when the original
  model includes non-positive regressors
- Improvements to syntax highlighting in script editor
- Numerous small GUI fixes
- MS Windows build: update cross-compiler to gcc-4.6.3
- MS Windows build: fix inconsistent zlib headers
- Internals: clean up the Minpack sources that we use for nls
- GTK 3 support: add some workarounds for GTK 2 features that are
  no longer properly supported

2012-03-29 version 1.9.8 (2012a)
- GUI: support use of named lists in the model specification dialog and
  other contexts
- GUI: add option of making the script editor and the model viewer
  windows use tabs
- GUI: add "reformat" option to summary statistics window for single
  series
- GUI: add keyboard shortcut help file
- Add a new practice script illustrating advanced use of mle command,
  and extend the discussion of mle in the User's Guide
- New function pxsum(): computes the cross-sectional sum of a series in
  the context of panel data
- stack() function for panel data: allow '*' in forming list of series
- Compaction of daily to weekly data: enable this even if the daily data
  are not dated
- "panel" command: add --nerlove option to use Nerlove's transformation
  in the context of the random effects estimator
- "system" command: various small fixes and enhancements, including
  greater computational efficiency
- "pca" command: add --quiet option and parameter to allow specification
  of the number of components to save
- "coint" command: add --verbose option and fix printout of model at
  last step of Engle-Granger test
- "graphpg" command: add "fonstscale" parameter (but also try harder to
  get the default font size right for various gnuplot versions)
- princomp() function: add an optional switch to use the covariance
  matrix
- matrix manipulation: enable use of the boolean operators "&&" and
  "||" as element-wise operations on matrices
- Function packages: prevent a package's "bundle-plot" function from
  appearing in the initial GUI listing of public functions
- Fix bug: avoid introducing "decimal commas" in setting size of PDF
  plots in gnuplot
- Fix bug: deletion of matrices within a loop: ensure that the GUI icon
  view is updated properly if it's open at the time
- Fix bug in serialization of matrices as XML (which broke, for example
  saving of VARs in gretl session files)
- Fix bug: the --to-file option for "labels" was broken
- Fix bug: misbehavior of substitution of named strings in some loop
  contexts
- Fix bug: breakage in handling of string-valued variables in CVS import
- Fix bug: possible crash in mle if a derivatives matrix is resized
- Fix bug: possible crash in GUI function package editor on adding a
  function to a package containing a single function
- Fix bug: data import from RATS databases broken on 64-bit systems
- Fix bug: the "smpl" command with --restrict option should support the
  full maximum length of the gretl command line (16K bytes)
- Various small fixes for spreadsheet data importers
- For third-party users of libgretl: improve handling of search for the
  gretl plugins
- Configure check for gnome desktop: support gnome 3.0
- Temporary files: use mkstemp() instead of mktemp()
- MS Windows and OS X: update packaged gnuplot to version 4.6.0
- MS Windows build: update cross-compiler to gcc-4.6.2
- Build tools: update to libtool 2.4.2
- Building from source: fix configure script for non-sse2 build

2011-12-22 version 1.9.7 (2011d)
- Add two nonparametric estimators: William Cleveland's loess and the
  Nadaraya-Watson estimator; these are available via the new functions
  loess() and nadarwat(), and they're also in the GUI Model menu
- Binary logit and probit: re-implement using Newton-Raphson for
  greater numerical stability
- Documentation updates, including a new chapter on Nonparametric
  methods in the User's Guide
- "store" command: add a --decimal-comma option to export "CSV" data
  using "," as decimal character (and ";" as column delimiter)
- "leverage" command: add a --quiet option and add calculation of the
  cross-validation criterion (available via the $test accessor)
- "rmplot" command (range-mean plot): add a --trim option to discard the
  minimum and maximum from each sub-sample
- "gnuplot" command: enhance the --with-lines option to permit using
  lines for some series and points for others
- "scatters" command: add a --matrix option and increase the maximum
  number of plots to 16
- Plots in GUI: add option to show semilog fitted line, and make the
  option to show a grid more configurable
- New function simann() provides user access to simulated annealing
- Speed up the production of bootstrapped confidence bands for impulse
  responses in VECM models
- Internationalized TeX output: always use UTF-8 encoding
- Online help: ensure that option flags don't break across lines (and
  also colorize them for emphasis)
- Cointegration testing: treat restricted exogenous terms as per Ox and
  PcGive (don't lag them in the initial OLS regressions)
- Fix breakage in GUI dialog box for ADF-GLS test
- Fix: the panel groupwise heteroskedasticity test failed silently if
  a group had just one usable observation
- Fix bug: breakage in mle when a "genr" line in the mle block assigns
  a new value to a submatrix
- Fix bug: possible crash in tsls when there are missing values and a
  regressor is all-zero at the complete observations
- Fix bug: "summary" command with --by option not respecting the
  incoming sample range
- Fix bug: filename encoding and dates recognition issues with the new
  xlsx data importer; also try harder to find sheet names/numbers
- Fix bug: segfault on running certain commands via the GUI after
  replacing the previous dataset with a new one
- Fix bug: crash on accessing a bundle via its icon if the bundle was
  replaced while the Icon view window was open
- Fix bug: crash on using the --quiet option with the "freq" command
  in a command loop
- Fix bug: breakage in processing the selection of quantiles for
  quantile regression in the GUI
- Fix bug: the third argument to eigsolve() was rejected even when it
  was valid
- Fix bug: the option of providing a named list of series as the left-
  hand term in a GMM orthogonality condition was not fully implemented

2011-10-17 version 1.9.6 (2011c)
- Add an importer for xlsx (Office Open XML) worksheet data
- cum() function: make this respect panel structure
- ranking() function: accept vectors as well as series
- New function, hdprod(): implements "direct row product" for matrices
- New functions for series: skewness() and kurtosis()
- New function uniq(): acts like values() but leaves the distinct values
  in their order of appearance
- New function pshrink(): compacts a panel series to a column vector
  with one observation per individual
- New function randint(): returns a random integer in a specified closed
  interval
- allow non-integer degrees of freedom for Student's t in cdf(), invcdf()
  and randgen()
- allow use of an (optional) "mask" argument with the panel statistics
  functions pmean() and friends
- list arguments to functions: allow use of anonymous lists
- extend the invcdf() function to the gamma and std. GED distributions
- GUI script editor: add Cut and Redo toolbar buttons, and also a
  Stop button to interrupt script execution; improve handling of Tab
  and Enter
- GUI session Notes: add option to pop up the notes on opening a
  session file
- build with SSE2 enabled: ensure that the C compiler SSE2 option is
  not wiped out if the user (re-)specifies CFLAGS when doing "make"
- Defining lists: document the wildcard operator, *, and add an
  ellipsis operator (two dots).
- VARs: (re-)enable HAC standard errors via a new option, --robust-hac
- "var" command with --lagselect option: make the table of information
  criteria available as $test
- "omit" command: add a --test-only option to prevent the reduced model
  from being saved as "last model"
- "add" command: add an --lm option to do an LM test, in which case the
  last model is not replaced by the augmented version
- "makepkg" command: add options to produce an XML index entry and a
  file of translatable strings suitable for use with gettext
- "freq" command: add facility to specify the number of bins, or the
  location and width of the bins; also add a --show-plot option for use
  in a script
- "tsls" command: add a --no-tests option
- Add facility for inspecting the list of gretl addons, under the GUI
  Help menu
- Download of textbook data-file packages: use sourceforge for better
  reliability
- Graphing ("gnuplot" command and GUI): generalize the option of
  separation using a binary dummy to allow use of discrete variables
- "boxplot" command: add --factorized and --panel options; also
  enhance the boxplot options available via the GUI
- "arima" command (native exact ML variant): add a --hessian option to
  enforce computation of standard errors using the Hessian; if this
  option is not given, allow use of OPG as fallback if the numerical
  Hessian cannot be computed
- X-12-ARIMA and TRAMO analysis: allow the user to supply names when
  saving series to the dataset
- Declaration of new series: set initial values to NA, not zero
- On OS X: save downloaded functions, databases and data file packages
  to the user's "Library/Application Support/gretl" directory
- MS Windows and OS X packages: update gtksourceview library to version
  2.10.5 to permit printing of scripts with highlighting
- Make gtksourceview-2.0 a dependency for the gretl build, and remove
  the "bundled" version of gtksourceview-1.0
- Fix bug: a nested "foreach" loop using a named list, with the name of
  the list subject to dollar-substitution via the parent loop, produced
  an "unknown variable" error
- Fix bug: The symbol "<-" for assignment to an object could get confused
  with a mathematical expression such as "x<-1.0"
- Fix bug: reading beyond array bound in numerical Hessian
- Fix bug in GUI function-package editor: could crash on adding a new
  function to a package
- Fix bug in GUI function-package editor: "edit code" not working for
  packages containing a single function
- Fix bug in GUI function-package editor: not apparent how to change
  the recorded date for a function package
- Fix bug in ADF test in GUI with data frequency 1: quadratic trend
  case being added even when deselected
- Fix bug in ARMA forecast for MA order > 1 and steps-ahead greater
  than the MA order
- Fix bug: ensure that we catch trailing junk at the end of a genr-type
  expression
- Fix bug: GUI scalars window not updating correctly if it is kept open
  while a script which modifies scalars is executed
- Fix bug: wrong readout of graph coordinates after doing "Replace full
  view" with a zoomed graph in the GUI
- Increase maximum command-line length to 16384 bytes

2011-04-22 version 1.9.5 (2011b)
- Add new translation: Greek (Manolis Tzagarakis and Ioannis Venetis)
- When building against gtk3, put the plugins into LIBDIR/gretl-gtk3
- "foreign" command: enable the --send-data option for Octave, in
  which case the gretl dataset is pre-loaded as a matrix named
  "gretldata"
- "coint2" (Johansen test): print the log-likelihood, plus improve the
  printing of the Pi matrix when exogenous regressors are present
- "coint2": add a --silent option
- VARs: add $fevd accessor to get the forecast error variance
  decomposition as a matrix; also add GUI access to forecast variance
  decomposition plots
- VECMs: add $vecGamma accessor to get the Gamma matrices (coefficients
  on the differences of the system variables) in standard format, plus
  $evals accessor to get the eigenvalues used in computing the trace
  test
- "tobit" command: add options to specify left- and/or right-
  censoring; also add --robust option
- gnuplot (command and GUI): add option to plot fitted cubic
- GUI plot dialog: add option to draw arrows on a graph
- GUI forecast dialog, for cross-sectional data: give option of showing
  confidence interval for mean Y rather than actual Y
- Fix a small memory leak when opening an *.asc data file
- New function colname(): retrieve a column name from a matrix
- New function eigsolve(): solves generalized eigenvalue problem
- New function NRmax(): Newton-Raphson maximizer
- New model accessors with string values: $depvar for the name of the
  dependent variable, and $command for the command word used
- Matrix "division": give the operators "\" and "/" the same semantics
  as in Octave/Matlab (left and right division)
- Remove the FGLS "arch" command from the GUI and add a deprecating
  note to its help text
- Lag specification for regressors (e.g. "foo(-1 to -2)"): the name of
  a list can now be substituted for the name of a series
- quantile() function: allow a vector for the second argument when the
  first argument is a matrix
- Copy data to clipboard in GUI: remove limitation of 8 series max
- "difftest" command: record $test and $pvalue
- Fix bug: wrong out-of-sample forecasts for ARMA models with seasonal
  MA terms
- Fix bug: wrong handling of string fields in ODBC data import
- Fix bug: spurious "unmatched 'if'" error under some conditions
- Fix bug: incorrect handling of observation markers in context of
  scatter plot "with factor separation"
- Fix bug: transposition not being done in expressions of the form
  matrix m = $accessor[range]', with trailing transpose symbol
- Fix bug: usable observations could be omitted when compacting from
  daily to weekly frequency, if the daily data contained "hidden"
  missing observations
- Fix bug 3285196 (respect indicated encoding when importing SPSS data)
- Fix bug: gretl could crash on start-up with no datafile specified
- MS Windows: update netlib lapack/blas to version 3.3.1

2011-02-24 version 1.9.4 (2011a)
- Change the default random number generator from GLib's
  implementation of the Mersenne Twister to the SIMD-oriented Fast
  Mersenne Twister
- Introduce "addons": approved function packages that are represented
  in the GUI menus
- Add an --accessors option to the "varlist" command, to expose the
  list of currently available accessor ("dollar") variables
- Add more panel data graphing options -- time-series of group means
  and boxplots by group -- and redesign the GUI for panel plots
- GUI code: modify to allow building against gtk3, with a configure
  option --enable-gtk3
- GUI icon view: provide a graphical representation for saved
  "bundles"
- GUI dialog for calling user-defined functions: several improvements
- GUI access to X-12-ARIMA: give option of writing and editing x12a
  .spc file
- GUI test-statistic calculator: fix a bug in the one-variance test
- New accessor, $vma: retrieves the vector moving average form of a
  VAR or VECM
- New function, inlist(): gives the position of a series within a
  named list or zero if the series is not present
- New function, isconst(): determines whether a series or vector has
  a constant value, and optionally tests for either time-invariance
  or cross-sectional invariance for panel-data series
- New function, strsub(): substitutes a specified replacement for a
  specified sub-string in its first (string) argument
- New function, ngetenv(): gets the numerical value of variable in
  the environment
- "estimate" command: document the --quiet flag; and also enable the
  --quiet option for "system"
- "summary" command: add an option to print summary stats for the
  columns of a named matrix
- "outfile" command: add facility to redirect output to stderr or
  stdout
- "setobs" command: add option to attach observation labels from a
  named file
- "heckit" command: switch to use of analytical Hessian for the
  covariance matrix
- New function, errmsg(): returns the gretl error message associated
  with a given integer error code
- New function, rownames(): complements the colnames() function for
  matrices
- New function mrls(); implements restricted least squares estimation
  for data in matrix form
- The sdc() function (column standard deviations): add an optional
  second argument to control the divisor
- New "set" variable, matrix_mask, which can be used to control the
  included observations when constructing matrices from series
- Accessors $test and $pvalue: generalize to allow matrix values
  (e.g. from the coint2 command); also ensure that these values get
  recorded when using "restrict" in connection with a system
  estimator such as SUR
- "catch" modifier for commands: make this catch a wider range of
  errors
- Functions corr(), cov() and fcstats(): accept two vector arguments
  in place of two series
- Allow deletion of local matrices within functions
- Remove deprecated aliases "noecho" and "seed"
- Remove redundant function "makemask"
- Fix some memory leaks in the gretl GUI
- Storage of data in gdt files: increase the precision for derived
  series such as logs
- Fix: reset model count on exit from user-defined functions
- Fix bug: incorrect parsing of command line containing a filename
  that includes left and/or right parentheses
- Fix bug: the $ec accessor for Error Correction terms produced bad
  results for VECMs where the loadings ("alpha") terms were estimated
  subject to restrictions
- Fix bug: estimates could get out of order for some equation systems
  if the constant was not given in first place among the regressors
- Fix bug: the "diff" command applied to a lead of a series could
  produce spurious values with panel data
- Fix bug: segfault with nested loops when the outer loop resamples
  the dataset and the inner one generates a series
- Fix bug: the function isnull() got broken when the argument is the
  name of a string variable
- Fix bug: incorrect parsing of ARIMA command with "gappy" AR lags
  specification, e.g. "arima {1 4 5} 1 1 ; y"
- Fix bug: the $unit accessor for panel data got broken
- Fix bug: the $kalman_t accessor was not working correctly for the
  case of a filter that employs time-varying matrices
- Fix bug: when compacting a dataset using the end-of-period option,
  one usable observation might be discarded
- Fix bugs 3180774 and 3183721 (64-bit build issues)
- MS Windows: update GTK stack and gnuplot

2010-11-29 version 1.9.3
- New estimation command "biprobit" (bivariate probit)
- New panel unit-root command "levinlin"
- Add help text for "dpanel"
- "restrict" command: enable the --full option for single-equation
  models estimated via OLS (makes the restricted estimates available
  as the "last model")
- "restrict" and "estimate" for equation systems: don't insist on a
  system-name argument, but allow a default of the last model
  (provided it was a system)
- GUI graphs: allow option of replacing the original graph with a
  zoomed view
- Panel time-series graphs in GUI: add another format option and try
  to use date information if available
- lrvar function: allow vector argument in place of series
- Iterated GMM: raise default maximum iterations to 250, and add a
  new "set" variable, "gmm_maxiter"
- Fix bug 3105271
- Fix bug: crash in lapack in case the number of instruments exceeds
  the number of observations in tsls
- Fix bug: recent breakage in quantreg command for the case of
  multiple tau values
- Fix bug: ensure that the main window gets updated when series are
  deleted via the console
- Fix bug: don't show an excessively long list of series in the
  dialog box for confirming deletion of series
- Fix bug: creation of matrices from data series in a loop which
  changes the sub-sample via --restrict
- Fix bug: setting "halt_on_error" off should not suppress printing
  of error messages

2010-11-03 version 1.9.2
- New command "fractint" (fractional integration test)
- The "pergm" command no longer does fractional integration testing
  as a side-effect
- The "open" command now supports http to get a data file (of any
  supported format) directly from the internet
- "kalman": allow a constant term in the state transition equation
- "modprint" command: allow a string literal for the second argument;
  support both comma- and space-separation of parameter names
- "dataset expand" command: add an "interp" modifier to use
  interpolation rather than repetition of values; also remove the
  option of going directly from annual to monthly frequency
- "heckit" command: enable the --robust option for QML standard
  errors and the --quiet option
- "mahal" command: add a --quiet option
- "arima" command: add new option --save-ehat
- pdf function: support the poisson and binomial distributions
  (giving the probability mass)
- New function invmills() to get the inverse Mills ratio
- New function bwfilt() to compute the Butterworth filter (thanks go
  to D.S.G. Pollock), plus GUI access under /Variable/Filter
  (time-series data only)
- New function polyfit() to obtain a polynomial trend line
- New function chowlin() to perform Chow-Lin interpolation of
  higher-frequency data
- New function varsimul() to simulate VARs
- New accessor $mnl_probs to get the estimated outcome probabilities
  for a multinomial logit model (plus GUI access under the Analysis
  menu in the model window)
- GUI interface to X-12-ARIMA: add more options to control the
  program's behavior
- GUI model specification dialog: add a "genr" button
- GUI, main window toolbar: add a button for direct access to native
  gretl databases
- Fix for multinomial logit: correct bias in favor of the base case
  in the reported fitted values ($yhat)
- Fix VAR forecasts: ensure consistency in exactly where a dynamic
  forecast starts
- Fix bug 3021540 (sorting dataset)
- Fix bug 3021854 (spreadsheet import with no numeric data)
- Fix bug 3050710 (build process: LDFLAGS not respected)
- Fix bug 3054932 (build process: libdir not used)
- Fix bug 3074946 (specific MA lags not remembered in ARMA GUI)
- Fix bug 3082926 (crash or bad session file when saving a session
  containing models with missing observations)
- Fix crashing bug in Wilcoxon signed rank test
- Fix bug: adf test with --gls option: don't use too many pre-sample
  values for the detrending regression
- Fix bug: crash in GUI when estimation of a restricted VECM was not
  successfully completed
- Fix for OS X: we now support Ctrl-click as equivalent to
  right-click (for popup menus, etc.)
- Fix for finding user's customized LaTeX preamble file
- Fix: more rigorous detection of whether TeX output is PDF rather
  than DVI
- Fix: when compacting a dataset, some values that should be missing
  were appearing as zero
- Traditional Chinese locale: encode text to CP950 for EMF files via
  gnuplot
- Drag-and-drop onto gretl main window: support database files (gretl
  native, RATS or PcGive) as well as regular data files
- Graphs in GUI: for plots that don't support the full graph editor,
  add a font selector
- Build: require libgmp (no longer an optional extra)
- Internals: modify GUI sources to ensure that gretl will build OK
  with the forthcoming GTK+ 3.0
- MS Windows: update Inno installer and add the officially recognized
  translations

2010-06-24 version 1.9.1
- New command: "makepkg", for command-line creation of gretl function
  packages (.gfn files)
- pdf, cdf and pvalue functions: add support for the Generalized
  Error distribution
- "dataset" command: add new sub-command, "renumber", for moving a
  series to a new position
- wls: amend the criterion for complaining that the weights are all
  zero
- logit/probit: correct ordering of estimates when the constant is
  not first in the supplied list of regressors
- Reading gdt data files: don't stop if a denormalized tiny value is
  found: accept what the C library gives and ignore errno
- Reinstate --basque start-up option for GUI program
- Fix for printing of month names on time-series plots in locales
  with multi-byte characters
- OS X: use the native Mac calculator app for gretl's calculator
  toolbar item by default
- GUI: add mechanism for defining named lists, and for setting the
  main window selection from a chosen list
- GUI: "Edit attributes" (of series) dialog: add option to change the
  position of a series in the dataset
- GUI model selection dialog: implement re-ordering of regressors via
  right-click
- GUI, right-click popup in main window: on selecting the correlation
  matrix option, give the user a chance to insist on a uniform sample
  for the correlations
- Internals: new, improved code for calulating the inverse Mills
  ratio (probit, heckit)
- API documentation: take this a step further, though it's still
  radically incomplete
- Remove the old genpois function

2010-05-02 version 1.9.0
- New command: "duration", for estimation of parametric duration
  models (e.g. Weibull)
- New command: "negbin", for estimation of count data models using
  the Negative Binomial distribution
- poisson regression: add overdispersion test and also --robust
  option to get a QML covariance matrix
- New command modifier, "catch" to catch errors and permit
  continuation of script execution
- "labels" command: add options to write variable labels to file, and
  to read labels from file
- Consolidate commands: the old "graph" and "plot" commands (ASCII
  graphics) are unified in "textplot"
- Enable full-text search of "online" help files
- Enable help for specific "settable" variables, as in "help set
  lbfgs"
- "mread": search the gretl working directory if the file is not
  found at first
- "dataset sortby": allow the use of a list to specify multiple sort
  keys
- ODBC import: enable extraction of multiple data series per SQL
  query
- ODBC: enable support in the binary packages for OS X
- Observation labels: permit non-ASCII UTF-8 characters
- Export of data to R, interactively: add a message confirming that
  the export worked
- "foreign" code blocks: add support for GNU Octave
- GUI: add export/import of variable labels
- GUI: enable choice of ordering for Cholesky decomposition for VAR
  impulse response plots
- GUI graph editor: add option to show a grid; add facility to
  display highlight bars in time-series graphs, e.g. NBER recession
  dates
- Filter functions movavg, bkfilt and hpfilt: offer greater control
  via additional optional arguments
- Add new functions, digamma, kdensity, monthlen and epochday (the
  latter two are calendrical)
- Add new built-in constant: "macheps" gets the machine precision
- OS X package: add icons and associations for gretl data, script and
  session files
- Add compile-time option to use openmp for multi-threaded matrix
  multiplication
- Fix bug: crash on exact collinearity when estimating a system of
  equations
- Fix bug: broken test output in tsls when the matrix of instruments
  is near to rank-deficient
- Fix bug: errors in Exponential Moving Average in GUI
- Fix bug: non-ASCII characters not handled in function package
  upload to server
- Fix bug: double normal cdf did not handle correctly some corner
  cases
- Fix bugs 2944000, 2956109
- Fix font-encoding issues on MS Windows: session-names with
  non-ASCII characters were not appearing in the gretl title bar; and
  the encoding was getting broken between copy and paste, e.g. in
  script windows
- Fix bug in Hausman test after tsls: ensure the sample size is
  consistent
- Fix integer overflow bug in Breusch-Pagan poolability test
- Graphing via gnuplot: require version >= 4.2.0

2010-01-24 version 1.8.7
- GUI enhancement: add apparatus to help keep track of gretl windows
- GUI menus: clean-up and consolidation
- New command: "qqplot" (Quantile-Quantile plots)
- Normal random samples: implement the Ziggurat method
- "dataset" command: document the "clear" keyword
- "rmplot" command: save $test and $pvalue
- "restrict" with --bootstrap option: record $test and $pvalue
- "corrgm" and "xcorrgm": allow the lag order to be given as a named
  scalar variable
- VECMs: add $ec accessor
- VARs: remove $vcv accessor
- VARs and VECMs: enable accessors $df, $ncoeff and $xtxinv
- BFGSmax function: add facility for supplying analytical derivatives
- Eviews data importer: handle more cases of .wf1 files
- BFGS: make the degree of verbosity tunable via "set bfgs_verbskip"
- Fix bug: crash on error in user_matrix_ols()
- Fix bug: "append" for data should work in more cases
- Fix bug: saving a model when there is already a saved model of the
  same name (in the GUI) caused a crash
- Fix bug: setting of sub-sample information on models estimated with
  a loop construct
- Fix bug: the GUI option for reporting standardized residuals for
  GARCH models got broken
- Fix bug: handling of on-the-fly matrices in "printf"
- Fix bugs: miscellaneous small GUI bugs
- Fix bugs 2918790, 2918783, 2918775, 2917053

2009-11-25 version 1.8.6
- Fix bug: the "print" command for series fails after exiting a loop
  with the --progressive option set
- ARIMAX models: follow the practice of most software and difference
  both the dependent variable and the exogenous regressors; a new
  option, --y-diff-only, restores the old behavior of leaving the
  regressors in levels.  This resolves bug 1972626.
- arima: fix some "corner case" bugs and extend the options that can
  be controlled via the GUI
- Add hyperbolic functions, asinh and friends
- heckit: use analytical score, and use hyperbolic transformation in
  estimating rho
- Fix bug: a native gdt file made from imported data could end up
  containing non-UTF-8 characters (and hence not be openable)
- Fix bug: the internal $error variable associated with the
  --continue option to (e.g.) "arima" could get stuck on within a
  command loop
- Fix bug: ensure that the "dataset addobs" command is recorded in
  the session command log when observations are added in the course
  of forecasting
- Fix bug: corruption in saving GARCH models in a session file
- "fcast": add a --plot option to generate a plot of the forecast in
  batch mode
- L-BFGS-B: add a "set" variable, lbfgs_mem, to control the number of
  corrections used in the limited memory matrix
- GUI dialogs for mle, gmm: add controller for BFGS details
- "scatters" command: add an --output option as for the "gnuplot"
  command
- Fix bug: the popup menu item "Execute line", in script windows, was
  not working
- Fix bug: bad Weibull plot (under "Distribution graphs") when adding
  Weibull curve to an existing plot that includes negative values of
  x
- Add facility to display normal and logistic CDFs
- Add convenience function: logistic()
- MS Windows package: update pango and gnuplot
- Scalar variables: improve GUI management, and add a --scalars
  option to the "varlist" command
- "mols" function: add option of retrieving the covariance matrix
- Add new function "weekday"
- Fix memory leak on repeated sub-sampling
- Miscellaneous small GUI fixes

2009-10-10 version 1.8.5
- Fix: avoid duplicating the return line when saving packaged
  functions that were originally old-style
- Several refinements for function-package editor
- Update the gretl function package DTD
- genr: improvements in type-handling for some tricky cases
- Internal clean-up: revamp gretl's mechanism for reading
  configuration info and setting paths at start-up
- Fix bug in handling of the R dll on Windows
- Function parameter [min:max:default] values: fix bug for locales
  using ',' as decimal separator
- Fix bugs 2843717, 2848633, 2865384
- Fix bug in corrgm() function when the series given as arguments
  contain missing values
- Add --to-file and --from-file options to "set" command
- Several refinements for the GUI "model table"
- Fix bug: error when trying to save the dataset, in the context of a
  saved-then-reopened session file
- Fix bug: in some circumstances model tests failed to respect the
  sample used when estimating the model, if the sample had since been
  changed
- Fix bug: wrong results from the "fcast" command after estimating an
  ordered probit or logit model
- Fix bug: the --output option to the "gnuplot" command was not being
  respected in the gretl console
- Fix bug: inconsistent handling of maximum command-line length in
  the context of loops
- GUI, main window, Sample menu: add an item to print details of the
  current sample status
- On closing GUI session, close any open graph windows
- RATS databases: recognize weekly data
- Eviews data importer: fix recognition of the starting month or
  quarter for dated time series
- CSV data importer: recognize the rather strange represent- ation of
  dates in the IMF's International Financial Statistics
- Add importer for SAS "xport" data
- GUI model window: add option to view the model in equation format,
  in plain text, for simple models
- $hausman accessor: make this available for panel models estimated
  via the random effects estimator
- add financial functions npv and irr

2009-08-28 version 1.8.4
- Fix breakage in GUI interface for calling user-defined functions,
  plus fixes for GUI function package editor
- Patches from Mandriva: build OK with -Wformat-security, and respect
  LDFLAGS as supplied by user
- Add "to" to the list of reserved words
- Enable testing of nonlinear restrictions on simultaneous equation
  systems
- Update docs and examples for the "new style" definition of
  functions
- Small modification to GUI series editor
- Try to make path-searching a little smarter for files referenced in
  scripts
- GUI language switcher: add a workaround for platforms missing
  proper locale aliases
- Stata dta importer: try to work around missing character encoding
  information
- ODS import: fix bug 2841292
- win32: update GTK+ stack to 2.16.5

2009-08-10 version 1.8.3
- Fix bugs 2819633, 2827358, 2828349, 2833434
- $stopwatch: use times() function if available, to include execution
  time of child processes
- Add function "mreverse" to reverse rows of a matrix
- Add function "deseas" to deseasonalize a monthly or quarterly time
  series using X-12-ARIMA or TRAMO/SEATS
- Remove function "strcmp" as redundant
- Add "sscanf" function
- Add function "pergm" corresponding to the pergm command
- Several fixes and enhancements for interaction with TRAMO/SEATS and
  X-12-ARIMA
- Many small GUI fixes
- Add (optional) support for Ox programs via the "foreign" command
- Ctrl-X in editing windows: cut text, don't exit
- Data importers: add a comment to the imported dataset saying where
  it came from
- 3-D graphs: use the wxt terminal in gnuplot if it's available
- Fix for putting RTF onto clipboard on OS X
- Observation labels ("case markers"): print up to 15 characters of
  such labels
- Support compaction of hourly (24 hours per day) data to daily
- Add "set" variable "csv_na" to control the representation of NA
  values in CSV output (also GUI selector for same)
- Remove old "set" variable, "protect_lists"
- Help windows: substantial revamp of GUI, plus fixes for dealing
  with translated helpfiles
- Add experimental function debugger: new "debug" command
- Stata importer: support current format 114 .dta files
- MS Windows: update the GTK+ stack
- Lists: allow formation of a new list by subtraction of one list
  from another
- "omit" command with --auto option: allow specification of a list of
  candidates for omission
- fix bug: "smpl --no-missing" was not always purging missing values
  in the case of panel data
- fix bug: possible confusion when creating a named list if the
  dataset contains a variable named "to"
- fix bug: wrong error message given by "system" command on
  encountering missing values
- fix bug: crash in estimating a system via LIML when the equations
  are given in TSLS fashion (i.e., y X ; Z)

2009-07-08 version 1.8.2
- Fixes for GARCH "corner cases"
- "summary" command: add --simple and --by=byvar options
- Fix another XLS import bug
- nls, mle, gmm, arma: allow continuation of scripts when these
  estimators fail to converge, in which case the variable $error is
  set to a non-zero value (new --continue option)
- "fcast" command: add more forecast evaluation statistics
- Add fcstats function to provide statistics for evaluation of
  forecasts
- GUI model window, Graphs menu: add scatter plot of actual vs fitted
  a la Theil
- Rationalize use of GRETL_KEEP_GOING and halt_on_error: induce
  consistency between CLI and GUI programs
- xtab command: add --matrix option to take frequencies from a named
  matrix
- add "anova" command (one-way and two-way) plus GUI menu entry
- Main window: make column headings clickable for sorting variables
  by ID number or name
- Enhancements to Edit Attributes dialog for data series
- "heckit command": fix problem with some residuals being unavailable
  via $uhat
- Printing: fix bad output from "pergm" command when the spectral
  density is very large
- Printing: revise printout of summary statistics for better
  consistency in non-English locales and for long variable names
- Fix bug: allow for the fact that TRAMO truncates long variable
  names to 8 characters in the names of its output file
- Fix bug: ensure that old X-12-ARIMA output files get deleted before
  a new run
- TRAMO and X-12-ARIMA: try to provide better information in case of
  errors
- Add GUI option: suppress detailed printout from X-12-ARIMA
- GUI menu Variable/Filters: add GUI access to the fracdiff function
- Several small fixes for the GUI
- Fix bugs 2806815, 2810219

2009-05-21 version 1.8.1
- Fix bugs 2533543, 2590417, 2604963, 2687954, 2734471, 2741374,
  2780592
- resample() function: add a second, optional parameter, namely a
  block length for resampling by moving blocks
- Ensure that gretl.lang (for gtksourceview) gets updated in Windows
  build
- Forecasts with confidence intervals: make the confidence level
  configurable via the GUI (and similarly for confidence bands on
  impulse response plots)
- VECMs: add a GUI selector for lags of any exogenous variables
- genr: make '^' (exponentiation) associate rightwards
- genr: support the syntax "func(args)[slice]" to select directly a
  submatrix from a function call that returns a matrix
- panel, random effects estimator, Hausman test: notify the user if
  the matrix-difference version of the Hausman test fails; also
  document the --hausman-reg option in the help entry for the "panel"
  command; and fix the covariance matrix in case --hausman-reg is
  chosen.
- VARs: support gaps in the lag structure (not for VECMs); also,
  allow single-equations VARs
- New GUI graph option: "Plot curve" under the tools menu, for quick
  plotting of a formula
- Chow test: add the option of specifying a dummy variable rather
  than a break point
- Boxplots: enable boxplot command in loops
- seq() function: add a third, optional step parameter
- Speed up loading of very large data files in gretl native format
- Fixes for handling of data files with over 999 variables
- Minor improvement to parsing of dates in CSV files
- "lags" command: accept a scalar variable for the parameter
  indicating how many lags to generate
- "logit" command: support multinomial logit via a new option,
  --multinomial
- ordered logit, probit: add count of cases 'correctly predicted',
  plus overall likelihood ratio test for all slopes = 0
- Graph editing dialog: provide more comprehensive font selection
  apparatus if gnuplot supports cairo
- "gnuplot" script command: add mechanism for naming the output file,
  and selecting EPS/PDF/PNG output directly
- Fix bug in binomial plot for 60 <= n < 170
- MS Windows build: update to gnuplot 4.3 CVS as of March 2009
- Enhancements for GUI menu item "Count missing values"
- tsls: add Stock-Yogo minimum eigenvalue test for weak instruments
- Modify the files in the win32 subdirectory of the gretl source to
  support building on MS Windows with mingw/msys
- Enforce the prohibition on using gretl command words as names for
  variables
- Script editing window: add "New" and "Open" buttons
- New function psdroot: find the Cholesky-type root of a positive
  semidefinite (and possibly singular) matrix
- New function filter: compute an ARMA-like filtering of a series
- Add a GUI language selector (by popular request!)
- "restrict" command: accept scalar variables in place of numerical
  constants
- "genr" with lists: allow boolean comparison of a list to a scalar,
  returning a series
- Add new string function "tolower"
- Rename "lmtest" command to "modtest"
- Add --comfac option to "modtest" for testing common factor
  restriction in models estimated via an AR(1) method
- Add user-level access to the Kalman filter, with a new command
  "kalman" and new functions kfilter, ksmooth and ksimul

2009-01-23 version 1.8.0
- Fix bug: crash in "Add random variable" dialog
- Translation fixes
- Add new command: "modprint"
- Remove obsolete commands: "rhodiff" and "hccm"
- Speed-ups for the pdf() function as applied to a series argument
- New option --numeric for the nls and mle commands, to force the use
  of numerical derivatives
- Numerous small graphing and GUI fixes
- MS Windows: fix for opening graphs in old session files
- Graphs: "display PDF" option: fix possible encoding issue
- GUI graph controller: new facility to add a line, defined via a
  formula, to an existing graph
- GUI graph controller: add facility to choose point style
- Gnuplot line-color selector: extend to 6 colors, and distinguish
  between setting the "palette" and setting ad hoc colors for a
  specific graph
- Scalars: make these accessible via the icon view window; enable
  copying to clipboard as CSV; enable entry of a formula (starting
  with "=") in scalar-editing window
- Fix encoding issue when copying to clipboard as plain text or RTF
- Boxplots: hand the production of these over to gnuplot
- New function: urcpval(), gives user access to James MacKinnon's
  p-values for unit root and cointegration test statistics (tau)
- New function: mpols(), enables multiple-precision OLS for
  user-defined matrices
- New function: toepsolv(), solves a Toeplitz system of linear
  equations
- New function: mcovg(), matrix covariogram
- Improve error-reporting in relation to GUI genr dialog
- Make parsing of input from GUI ARMA dialog more robust
- New feature: add importer for SPSS .sav files
- CSV importer: try to handle time-series data in reverse
  chronological order
- "fcast": allow variables for the startobs and endobs arguments; add
  "rolling" k-step-ahead option
- Fix bug in ADF --verbose printout (wrong p-value shown for one
  lagged difference in some cases)
- GUI plot editor: translate the gnuplot style strings
- Switch to more compact tabular form for presenting model statistics
- OLS and fixed effects: add option to calculate p-value for the
  Durbin-Watson statistic
- Add accessors $Fstat and $chisq for the overall F-statistic or
  chi-square test from the last model
- Make the "restrict" command available for nls, mle and gmm
- Improve forecasting options for nls models
- Add model menu item: "Modify model", under the Edit menu, provides
  a clone of the model specification
- Loops: allow the "gnuplot" command, operating strictly in batch
  mode
- New command "intreg": implements interval regression
- Several updates to the documentation
- Fix bugs 2042328, 2472732, 2510727, 2510759

2008-09-28 version 1.7.9
- Revamp the data structure "wizard"
- Fix bugs 2102478, 2116172, 2118506
- Periodogram graph: fix bug for case where the locale decimal
  separator is not '.'
- Add Russian translation, Turkish translation
- Small GUI fixes
- Modifications to web-downloader for new server settings
- Fix for non-ascii file names in session files on MS Windows
- genr: fix for unary minus in exponentiation (e.g. x^-.5)
- nls: fix R^2 printout
- dummify function: accept a second argument (see the help for
  details)
- ordered probit/logit: fix bug with displaying these models in the
  GUI model window

2008-09-14 version 1.7.8
- Add a language-switching option to the gretl GUI (under
  Preferences/General)
- Improve formatting of HCCME options pane
- Fix breakage in "rename" command (renaming series)
- Fix bug 2089048
- Enable Chow test for non-time series datasets
- Revise formatting style for model output
- Change the label "standard error of residuals" to "standard error
  of the regression"
- Allow users to change the text size in help windows
- Fix two more bugs in connection with user-defined functions in the
  context of a sub-sampled dataset
- Fix bug: with the --panel-vars option to the "setobs" command,
  check more carefully the validity of the supposed unit and
  time-period index variables
- Chow test: perform a robust version if the original model was
  estimated using an HCCME
- OS X package: fix for the problem whereby GTK could lose track of
  its image-loading modules
- CSV data: improve recognition of daily dates
- PCA: fix column-order of components in printout for the case of
  more than 7 components
- Small fixes for opening of datafiles in GUI
- GARCH: add --nc option to suppress the constant in the mean
  equation; add --fcp option to use Fiorentini et al code; expand and
  update help entry
- Periodogram graph: always base y-axis at zero
- Seasonal ARMA: fix for bad handling of automatically added scalars

2008-08-28 version 1.7.7
- Revamp of internal handling of scalar variables
- The --preserve option to the "nulldata" and "open" commands now
  preserves existing scalars as well as matrices
- Windows package: update to GTK+ 2.12.11 and friends
- Inside functions: restrict the smpl command within the bounds set
  on entry to the function
- setobs command: if used inside a function, revert the effects on
  exit
- ordered probit/logit: fix for the case where the dependent variable
  does not form a continuous integer sequence; fix reporting of
  information criteria; switch to the mode of presentation of
  cut-points used by Stata and R
- string-editing dialogs: ensure we have a cancel button
- Saving data when the dataset is currently sub-sampled: fix breakage
  whereby the option to restore the full dataset was not shown
- Naming variables: put in place more stringent checking to avoid
  name collisions across series, scalars, matrices, etc.
- VARs in saved sessions: ensure that we save the information needed
  for subsequent bootstrap analyses
- Fix the mechanism for searching for a user's customized LaTeX
  preamble file (got broken at some point)
- LaTeX compilation: be more lenient -- getting some output on
  standard error does not necessarily mean that compilation has
  failed
- Determining the main gretl directory: try to handle the case where
  the user has a stale ~/.gretl2rc file
- Minor OS X fixes
- Respect keyboard "Esc" as dialog "Cancel" more consistently
- Variable selection dialogs: allow use of right and left arrow keys
  to activate the "Add" and "Remove" buttons
- Linear models without a constant: print the centered R^2 as well as
  the uncentered
- Fix for reading native data files containing auto-generated lags:
  re-establish the lag info correctly

2008-07-30 version 1.7.6
- Fix bug: revise the way that list arguments to user-defined
  functions are handled, to avoid potential namespace collisions
- Add menu item: Variable/Normality test
- Add $xlist accessor: gets the list of regressors from the last
  model
- Add $version accessor: gets the gretl version
- Add $windows accessor (1 if running on MS Windows, else 0)
- Add $datatype accessor (see function help)
- Remove some redundant preferences items
- Fix bugs 1996156, 1996161, 2017872, 2027121
- MLE fixes
- Fix for RTF output from GUI model table
- Function package help: ensure this is not truncated
- Fix bug: incorrect generation of NAs when doing "genr unitdum" on a
  sub-sampled panel dataset
- Add new panel data functions: pmax, pmin, pnobs
- Internal: recode parts of the gretl GUI to avoid dependence on
  deprecated GTK APIs
- Speed-ups for loops containing genr commands
- Several fixes for reading and writing gretl session files
- Function packages: add facility to append a sample script
- Enhancements for GUI function-packager
- File dialogs: try to ensure that focus falls back to the right
  window when such windows are closed

2008-06-13 version 1.7.5
- max() and min() functions: extend the syntax to allow a list
  argument
- Reading CSV data: automatically substitute '_' for illegal
  characters in variable names
- Support DESTDIR for make install
- Add Weibull distribution to the various gretl probability
  distribution functions
- Fix for parsing a restriction with leading numerical term
- New functions: pdf, sdc, msortby
- User-defined functions: allow a descriptive string to accompany
  each parameter, for use in GUI
- Add $unit accessor to get a panel unit index
- Add "--breusch-pagan" option to lmtest command (with --robust
  option to use the Koenker robust variance estimator); also add this
  test to the GUI
- Fix some bugs in sub-sampling of panel datasets
- Revise the GUI for setting the sample range for panel data
- Improvements for panel time-series graphs
- Fix bug in importing data with long numeric observation labels
- printf command: allow matrices in place of scalars (e.g. using "%f"
  or "%g" conversion)
- GUI script output window: add option of making output "sticky"
  (running a script appends to text)
- Add log-axis option to GUI graph editing dialog
- GUI program: add right-click popup menus to more windows
- Fix bugs 1929957, 1922915, 1951681, 1954428, 1954838, 1960861,
  1969680, 1972629, 1972613, 1980775
- Add guard against unmatched "if" in loops, functions and scripts
- Fix bug: VARs and equation systems not getting removed as "last
  model" on exit from user-defined functions, which could cause
  strange errors in complex scripts
- Fix for forecasts from equation systems displayed in the GUI
  program
- Updates to some screenshots in the User's Guide
- pca command: add --covariance option to base the analysis on the
  covariance matrix instead of the correlation matrix
- corr command: document the --uniform option and add it to the GUI
- Fix bug: loops inside conditionals inside a loop were not executing
  properly in some cases
- X-Y scatterplot: add option of controlling for a third variable
- hsk command: fix for the case where the model includes a dummy that
  is specific to a particular observation
- arima specification dialog: add checkbox for basing standard errors
  on the Hessian
- store, outfile, etc.: if the filename starts with "~/", expand this
  to the user's home directory, if possible
- Search for data file collections: add the user's gretl data
  directory ("dotdir") to the path searched
- "append" command: try harder to make this do what the user is most
  likely to want in the case of panel data
- frequency distribution in GUI: allow choice of bin size, as with
  frequency plot
- fixed effects estimation: print the average constant
- eigengen function: make this behave as the manual says
- OLS anova: add p-value for the F-statistic
- Fix VECM forecast graph in GUI ("pre-forecast" fitted values were
  not integrated)
- "open" command: add options for controlling importation from
  spreadsheets
- add "set debug" option for deugging user-defined functions
- GUI function package: add option to save the packaged functions as
  a regular gretl script
- Fix bug in modification of LMF autocorrelation test (bug was
  introduced in gretl 1.7.4)
- Script editor: add option to show line numbers
- Native database windows: add right-click popup menu
- Local function package listing: sort alphabetically
- logit/probit: add code to detect perfect classifiers
- "tabprint" model-printing command: add --rtf option to produce RTF
  output rather than LaTeX
- Windows build: update to Lapack version 3.1.1
- Add quantile regression ("quantreg" command)
- Add experimental support for importing data from an external
  database via ODBC
- Add "normest" command to test a series for normality, with options
  of Doornik-Hansen, Shapiro-Wilk or Jarque-Bera
- Model window, confidence intervals for coefficients: add option of
  changing the confidence level from the default of 95 percent; and
  similarly for confidence ellipses
- Add facility for writing and executing R scripts via the gretl GUI
- Durbin-Watson statistic: supply a larger table of critical values
  (thanks to Marcin Blazejowski and Tadeusz Kufel)

2008-03-21 version 1.7.4
- Fix for ADF-GLS test with missing values
- Fix for detection of unit-diagonal matrix (oops!)
- Merge fit and fcasterr commands with fcast
- Add $fcast and $fcerr accessors for use with fcast
- Autocorrelation test: use Kiviet's original 1986 formula for the
  LMF statistic
- "system" command: enable naming of systems in the manner "sysname
  <- system"; enable forecasts; make parsing of identities more
  robust; enable TeX view/print in GUI; add new accessors $yhat,
  $sysGamma, $sysA, $sysB
- "estimate" command: add --quiet option
- remove obsolete command: multiply
- Consolidate the commands corc, hilu and pwe into one new command
  with options: ar1
- Fix for the case of graphing 6 time series together
- Fix bugs 1908139, 1909469
- Fix documentation of $stopwatch
- Move handling of strings into "genr"; add strlen function
- fdjac and BFGSmax functions: don't require that the function-call
  argument be wrapped in quotes
- "corr" command: allow printing of ranked data for Kendall's tau as
  well as spearman (verbose option); also add a verbose check-box to
  the rank-correlation dialog
- User's Guide: add a discussion of Arellano-Bond
- Enable "delete" command for saved strings
- Enable naming of matrix columns, via colnames function or the GUI
  matrix editor
- Enable "dataset resample" in loops (experimental)
- Runs test: enable the "--difference" option in the CLI; handle the
  case where positive and negative values are not equiprobable by
  default, but add an "--equal" option to impose the equiprobability
  assumption
- Fix for "data error" in VECM autocorrelation tests (for now we'll
  just do Ljung-Box)
- Fix sub-sampling bug (new in 1.7.3)

2008-02-29 version 1.7.3
- Fix for 64-bit platforms: don't use "long" as the C counterpart of
  Fortran 77 "INTEGER"
- Make the rcond function available for asymmetric matrices
- Enable the $yhat accessor for fitted values in equation systems
- Add Italian function help to Windows build
- Weekly to monthly data compaction: respect the user's choice of
  compaction method, as claimed
- Add trimr matrix function (as in Gauss)
- Extend matrix "division" a la Gauss
- Disallow user functions with the same name as a built-in function
- Update several screenshots in User's Guide

2008-02-25 version 1.7.2
- list-creation: add "dataset" option to use all currently available
  data series
- Fix bug in recording result of TSLS heteroskedasticity test
- Add sscanf command (a subset of C sscanf functionality)
- Add shell capture for strings via $(shellcommand)
- Paths stuff: add (non-configurable) "dotdir" to hold per-user
  automatically-created files
- Fix bugs 1861010, 1868859, 1869271, 1870459, 1870973, 1871110,
  1871135, 1873625, 1874601, 1881849, 1897648
- Rationalize frequency plot dialog
- Add Help item to forecast dialog
- Fixes for matrix "dot operations"
- Fix breakage in graph color selector
- Fixes for ODS spreadsheet importer
- Document the --auto option for the "omit" command, and add a GUI
  handle for it
- MS Windows and OS X packages: update to gnuplot 4.3 (CVS)
- Graphing internals: use UTF-8 for internationalized strings
- Models having an exact fit: block various invalid tests
- det() function: fix for singular matrices
- GUI script editor enhancements
- Allow drag of database from databases-on-server window to local
  native databases window; also function packages from server to
  local function package window
- Add basic support for the DF-GLS test via a new --gls option to the
  adf command
- Add selifc and selifr matrix functions
- Generalize several functions to accept matrix as well as series
  argument, e.g. quantile, diff, cum, resample
- Add new accessors for TSLS test results: $hausman and $sargan
- Many small improvements to the GUI
- Add systematic documentation for the functions available in the
  genr command
- Enable "append" command in loops
- Ordered logit and probit: don't insist that the dependent variable
  has a minimum of zero
- Windows installer: update GTK version, packaged zlib1.dll, and
  gtksourceview DLL.
- Fix bug in arima auto-differencing, for non-seasonal order greater
  than 1 plus seasonal differencing

2007-12-25 version 1.7.1
- Add documentation for "set stopwatch"
- Add movavg function to genr (not documented yet)
- Add autocorrelation and heteroskedasticity tests for models
  estimated via TSLS
- Add "dataset resample n" command to resample observations with
  replacement (not documented yet)
- Add functions for matrix I/O from/to text files
- Fix garch bug when p!=q
- Fix bugs: 1848487, 1847908, 1850842, 1848039, 1840179, 	1842439,
  1841098, 1843664, 1835707, 1841107, 1841774
- Fix bugs in saving/re-opening restricted VECM models as part of a
  gretl session
- Fix bug in CUSUM/CUSUMSQ plots for time series data frequency
  greater than 1
- Work around strange behavior of gnuplot 4.2 on Ubuntu
- Reinstate user-level choice of "Windows-look" emulation
- Reinstate user choice of menu font on Windows
- Script editor: add right-click popup with menu items to
  comment/uncomment selected block of commands, and to execute a line
  or region
- genr: fix for case where closing parenthesis is missing at the end
  of a formula
- OS X: replace fftw library with an i386 build
- Toolbar: use GTK stock icons where possible
- Gnuplot commands editor: fix behavior of save button
- Time series plot, more than one series: add option to show separate
  small plots
- Output from script execution: reuse existing output window if it's
  left open
- Add set variable "fcp" to use Fiorentini, Calzolari and Panattoni
  GARCH code
- Add set variable for max iterations in a "while" loop
- Fix bug: missing data handled incorrectly in ascii graphs
- Removed obsolete genr function varnum()
- Renaming session objects: move to popup menu
- Saving text from output windows: give choice of saving to file, or
  as session icon
- Commands allowable in loops: enable all but a fairly small subset
- Shell command: when invoked in gui console, send output to gui
  console
- Fix handling of "quit" when it's blocked by "if"

2007-11-27 version 1.7.0
- Add heckit estimator
- Add estimation/testing for restricted VECM models
- Fix for loop on empty list
- Fix for remaining issues with apostrophes in graph titles
- Fix for lists as arguments for user-defined functions
- Fix for saved sessions after using Forecast menu items
- Fix for long variable names in Model Graph menus
- Improve formatting for nonparametric difference test
- Improve formatting for "freq" command; also add --silent option for
  this command
- Add ceil() and floor() functions in genr
- Add "--p-values" option to show p-values instead of slopes for
  logit, probit models
- Add options to GUI for xtab command (cross-tabulation); also add
  Fisher's Exact Test for 2 x 2 tables
- Fix for graphing the time trend, and for graphs displaying more
  than 8 series
- Fix for length of correlogram on weekly data
- Fix for null matrix arguments to user functions in GUI
- Fix for floating point values in "set" when using decimal comma
- Fix for opening cross-sectional gretl data sets in R version 2.5.0
  or higher
- Fixes for autoregressive genr formula: speed-up, and fix bug when
  such formulae are used in an nls/mle block
- Double maximum length to gretl command line to 8192 bytes
- Gamma p-values: switch to shape/scale parameterization
- Spearman's rho: fix for case with ties
- Allow for syntax change re. missing values in gnuplot 4.3
- "corr" command: add --spearman and --kendall options
- Rank correlation in GUI: add Kendall's tau option
- Fix a few issues with extreme values in cdf, pvalue code
- add gamma() function in genr to generate gamma random variable
- Modify Locke's test to use Kendall's tau
- Add ginv() (Moore-Penrose inverse) matrix function
- Add multivariate Portmanteau test for autocorrelation in VARs
  (Ljung-Box)
- Allow concatenation of multiple short-form options, as in "-rdq"
- Modify retrieval of info from VARs: $coeff gets the matrix of
  coefficients, $compan gets the companion matrix
- New accessor: $gmmcrit gets the GMM criterion for a model estimated
  via GMM
- gretlcli: Ctrl-X exits without prompting for save
- Databases: allow selection of more than one series for display,
  graphing, importing
- Databases: allowing deletion of series from native gretl databases
  (if the user has write access)
- New command, "dataset": subsumes the old "addobs" and "transpos",
  while adding new options
- fftw DLL for Windows: fix a problem experienced on some Windows
  systems
- Generation of random variables in GUI: use an interface consistent
  with that for p-values, critical values, etc.
- Fix for XLS importer with non-zero column offset
- Improve error detection and recovery for adding case markers from
  file
- Graphs: try to respect line color choices when exporting to
  postscript and PDF
- Small improvements to built-in data editor
- ARMA: allow specification of particular AR and/or MA lags (int the
  non-seasonal component only)
- Add importer for Open Document Spreadsheet files
- MS Windows: update to version 2.12 of GTK runtime
- MS Windows: update to gnuplot 4.2.2, and add switch in graph
  editing dialog to prevent anti-aliasing of lines
- GUI linear restrictions dialog: fix bug whereby parameter names
  were not accepted
- Saving databases: fix effect of --overwrite flag to do what the
  manual says
- Databases on Windows: look in the gretl user directory as well as
  the system db directory
- add argname() function for use in user functions
- Panel, unit-weights: fix omit command
- Fix bug in mailer dialog (crash when closed via window manager)

2007-05-17 version 1.6.5
- Fix new breakage in configuration of user directory
- Updates to manual
- Mark some more strings for translation
- Add new menu set /Tools/Nonparametric tests, with GUI access to the
  "difftest" and "runs" commands
- Add --difference option for runs command
- Various small bug-fixes

2007-05-13 version 1.6.4
- Fix breakage in relation to the Windows registry
- Fixes for accented characters in graphs, on systems with UTF-8 as
  the standard character encoding
- Additional fixes for Polish text in graphs

2007-05-10 version 1.6.3
- Add facility for bootstrap analysis in GUI, for OLS
- Model table: fixes for including panel models; allow up to 12
  models; formatting enhancements
- Fix bug in panel autocorrelation test (lmtest command)
- Add fft() matrix function (Fast Fourier Transform)
- Add cmult() matrix function (complex multiplication)
- Add quantile() function in genr
- Add production of restricted estimates to the "restrict" command as
  applied to VECMs
- Multiple fixes for session icon handling
- LAD models: print the median of the dependent variable
- Matrix properties window in GUI: add an indication of whether or
  not a square matrix is idempotent
- Panel data, pooled OLS model: when robust standard errors are
  chosen, use the Arellano-type HAC estimator (well, it's HAC when
  the time-series dimension is small); also offer Beck-Katz Panel
  Corrected Standard Errors
- Apply the above to tsls in a panel context also
- Panel data, "summary" command for single variable: show the within
  and between standard deviations
- Add "--quiet" option to lmtest command (don't print the auxiliary
  regression)
- Observation labels: ensure these are properly XML-encoded when
  saving a data set as gdt
- Fix bug that could cause a crash when exiting the program on MS
  Windows
- Fix bug: crash when saving a graph as an icon, when the icon window
  is currently displayed
- Fix an encoding issue with the command-line help files on platforms
  where the default encoding is UTF-8
- Correlation matrix: try to be smarter in face of non-aligned
  missing observations
- CSV data: add support for Mac-style text files
- "loop" command, "progressive" option: fixes for the case where this
  is invoked for loops other than the simple "count" type
- Further optimization of gretl_matrix functions
- Various modifications to the configuration process

2007-03-24 version 1.6.2
- Add Poisson distribution to p-value finder
- Fix breakage in GUI "graph page" apparatus
- Graph page: give color / monochrome option
- Bivariate scatterplots: give the option of showing various sorts of
  fitted line: linear, quadratic, inverse or loess
- Monochrome EMF graphs: make sure point types are distinct for
  different series
- Internal clean-up of the graphing code
- Make frequency plots more configurable via the GUI
- Fix memory leaks in GUI graph editor dialog
- Bugfix: estimating models inside nested functions could cause a
  crash
- Session icon window: don't display temporary matrices, generated
  within functions
- Icon window: fix display on one-character object names
- Fix memory leak when generating some sorts of matrices
- Add option of using Parzen or Quadratic Spectral kernel (the
  default is Bartlett) when computing HAC covariance matrix
- Add a toolbar to windows that display lists of files
- Several fixes and enhancements for function package editor
- Fix for "omit" command in relation to arbond estimation
- Correlation matrix, etc, in GUI: don't disable menu items if only
  one variable is selected
- System estimation: fix breakage of the "save=" mechanism for
  residuals and/or fitted values
- gmm: improve syntax handling for orthogonality conditions
- Update the API documentation (still very much incomplete)
- Update gnuplot to version 4.2.0 in the Windows installer

2007-02-26 version 1.6.1
- Revamp for internal "genr" mechanism plus some user-visible changes
  to genr
- Make the "delete" command do what the manual says
- Doing "Edit attributes" on a newly generated variable: you can edit
  the formula and hence change the content of the variable
- Displaying table of summary statistics for multiple variables:
  allow slightly longer variable names before falling back from
  combined tabular format to individual tables
- Sorting variables in main window: always revert to sort by ID
  number after making changes (e.g. loading a new dataset)
- Main-window variable listing: don't always jump to line 1 after
  making changes
- When you "Save as" in the Command log window, ensure that all the
  regular script-editing signals are properly connected (e.g. the
  state of the Save icon responds appropriately)
- "dummify" command: add options --drop-first and --drop-last; make
  --drop-first the default when the dummify() construct is used in a
  regression list
- Add ordered probit analysis for the case where the dependent
  variable is discrete but not binary
- Add computation of generalized residuals in various estimators
- Revamp Tobit estimation: use BFGS instead of BHHH, allow --robust
  option and add normality test
- Fix some bugs and inconsistencies in relation to the Ljung-Box
  statistic and ACFs
- Fix bug in the Baxter-King filter routine
- Add the CUSUMSQ test alongside CUSUM
- Add test version of Arellano-Bond dynamic panel data estimation
- Fix bug in GUI spreadsheet in relation to adding variables
- Fix bug in restricting the sample in the GUI, for the case where's
  there's already a restriction in place
- QLR test: add time-series graph of F test
- new command "xcorrgm" for cross-correlogram of 2 variables
- Add bivariate normal to cdf()
- New modular engine for garch estimation (no user-visible changes
  for now)
- Make window size for semiparametric estimators of the fractional
  integration parameter adjustable by the user
- Make the number of bins for a frequency plot adjustable via GUI
- Add facility to generate Binomial and Poisson random variables
- Row format for tabular output of models in TeX: make this
  configurable
- Add several matrix functions
- Add nonlinear GMM estimation (experimental)
- Numerous small bug-fixes

2006-09-13 version 1.6.0
- Revamp mechanism for saving sessions in gui program (we now save
  sessions as zipfiles containing XML representations of any models
  that have been estimated)
- Add "native" exact ML estimation of ARMA models using the Kalman
  filter
- Saving data in native gretl format: make gzip compression the
  default
- Add some basic functionality for analysis of discrete variables.
  New behavior of frequency distribution, plus new commands:
  "discrete" (interpret variables as discrete), "dummify" (create a
  set of dummies coding for the values of a discrete variable), and
  "xtab" (cross-tabulation of two discrete variables)
- Don't add an extra newline at the end of plain text data files
  (e.g. CSV)
- "restrict" command for single equations: add a printout of the
  restricted coefficient estimates and standard errors
- Add mechanism for packaging user-defined functions so as to make
  these available for other users; also add a mechanism for
  downloading such packages from a server, and for uploading new
  packages to the server
- Redefine the weight variable in gretl's "wls" command, for better
  compatibility with other programs: the weight var is now defined as
  the series of diagonal elements of the weighting matrix, so
  existing gretl scripts that use wls should square the old weight
  variable
- Don't print the "model has no constant" message, and do not use
  special methods to calculate R^2 and F, if the set of regressors
  spans the space of a constant
- Indexing of coefficients in "restrict" command: standardize on
  using a 1-based index in all contexts
- Revamp panel data estimation: redefine the "panel" command for
  fixed- or random-effects estimation, rename the old "panel" command
  as "paneldat"; refine calculation of Hausman test statistic
- Lags in main window: make these visible under their parent
  variable, via a "twisty" triangle
- Revamp multiple-precision models: add more statistics, and make
  them available for capture via genr
- Revamp test for differences of two means in the GUI hypothesis test
  calculator
- Imposing panel structure on a data set: add the option of defining
  the structure by reference to two index variables, one for the unit
  and one for the period -- this is implemented in the "setobs"
  command and the GUI data structure wizard
- Add --robust option to nls command (nonlinear least squares)
- Add --hessian and --robust options to the mle command, which
  respectively produce a covariance matrix based on the Hessian and a
  QML sandwich estimator of the covariance matrix
- Add Quandt likelihood ratio (QLR) test for structural break
- ADF and KPSS tests: add option to difference the selected variable
  before testing
- Delimiter for "CSV" files: add semicolon to the list of options
- VECMs: make Johansen's alpha and beta retrievable as matrices with
  identifiers $jalpha and $jbeta
- Several bug-fixes for the matrix manipulation facility, plus a few
  new functions (meanr, meanc)
- GUI menus restructured and polished
- Add facility for multiple time-series graphs from the GUI
- Revamp the "--ten" option for printing variables to 10 digits:
  replace with a configurable "--long" option
- Graph editing dialog: make the line width configurable, and also
  make the preferred line width settable per variable in the "Edit
  attributes" dialog
- Data import and export: add option for reading and saving data in
  JMulTi format
- Databases: add capacity to read PcGive in7/bn7 databases
- Gretl command minibuffer: model commands now produce GUI model
  windows (for single-equation methods)
- QR decomposition option: fix the F-statistic values produced for
  autoregressive models
- pvalue() function: always return the right-hand value, but add a
  complementary cdf() function that always gives the left-hand value
- NIST linear regression test suite: re-express accuracy in terms of
  log relative error, plus other enhancements
- Generating random variables: add option to generate t and
  chi-square values in GUI; add option of setting the PRNG seed to
  the GUI variable-generation dialogs
- Time-series filters: Add Hodrick-Prescott and Baxter-King filters
  as a GUI menu item, along with simple moving average and
  exponential moving average
- Engle-Granger cointegration test: improve printout, add option to
  test down for the lag order, and fix an issue with the selection of
  the MacKinnon p-value for this test
- Tobit: enable handling of missing observations for this estimator

2006-03-24 version 1.5.1
- Add matrix manipulation functionality
- Fix translation bug for VAR menus
- Fix bug in assignment of values returned from user-defined
  functions
- Small fix for helpfile formatting
- Add calculation of Gini coefficient and Lorenz curve to GUI
  Variable menu
- Provide option of including seasonal dummy variables in
  Dickey-Fuller tests
- Add two more "genr" functions: qnorm (quantiles of normal
  distribution) and gini (Gini coefficient)
- Fix some bugs in handling of named lists, and start documenting
  this properly
- Enforce use of '.' as decimal separator in genr formulae
- Fix filename encoding issue with opening of CSV files
- Eliminate deprecated command "sim"
- Extend maximum length of variable names to 15 characters
- Disable "shell" command by default (it can be enabled under
  /File/Preferences)
- Change the names of the internal variables coeff, stderr and rho to
  $coeff, $stderr and $rho
- Add various keyboard shortcuts to main window, including Alt-X for
  a "gretl minibuffer" a la Emacs
- Time series model menu: add option for selecting optimal lag length
  for a VAR, based on information criteria
- VARs: add a "Tests" menu item to GUI VAR window, permitting tests
  for omission of exogenous variables (if any)
- Model window, Graphs menu: if the data are time series, add options
  to view the correlogram and periodogram of the residual from the
  model
- Add Hannan-Quinn criterion in all contexts where Akaike and and
  Schwartz criteria are shown
- Various fixes for model selection dialog
- win32: fix the issue whereby copy-and-pasted EMFs had a large
  margin to the top and right
- win32: fix opening of files with non-ascii characters in their
  names
- XLS and Gnumeric importers: supply automatic varnames if no
  variable names are present
- ARMA: Alter presentation of parameter estimates (call them "phi"
  and "theta"); provide native multiplicative seasonal models
- Fix issue with spectrum plot when the order of magnitude of the
  series is very low
- Introduce "set" parameters for tweaking the BHHH algorithm
  convergence criteria
- Add GUI lag selector
- VARs: add numerical output to VAR roots plot
- Allow commands like var and arma to be specified with a scalar
  variable as order
- Add "dsort" command for reverse sorting
- Enhance and robustify script capabilities

2005-12-15 version 1.5.0
- Add VECM (Vector Error Correction Models) for time-series data
- Add confidence ellipse option for two coefficients, in model window
  menu
- New command "mle" : a general-purpose maximizer of log likelihood,
  using the BFGS algorithm -- works much like the "nls" command,
  taking a user-specified log likelihood function as input, along
  with (optionally) derivatives of the log likelihood with respect to
  the parameters
- More XLS importer fixes
- Add support for seasonal ARMA; add "sdiff" command (and
  corresponding function in genr) for creating seasonal differences
- Add capacity to produce time-series graphs with panel data sets
- Accommodate custom time-series frequencies
- Johansen cointegration test: extend to cover all 5 cases, produce a
  fuller report (loadings, long-run matrix)
- Add bootstrapped confidence intervals for impulse responses in VAR
  models
- Add test for multivariate normality of VAR residuals
- Add autocorrelation and ARCH tests for VAR equations
- Add printing of cross-equation covariance matrix for VARs
- Add combined plot of residuals for VARs
- Add combined impulse response plot for VARs
- Add log-likelihood, AIC and BIC for VARs
- Add inverse roots plot for VARs (Jack Lucchetti)
- Add log-likelihood for models estimated via OLS
- Add "robust" option for logit and probit (compute QML or
  Huber-White covariance matrix)
- Add "robust" standard errors option for WLS
- Remove overly verbose notification dialogs
- Add importers for Eviews workfiles and Stata .dta files
- Editable windows: show Save button as disabled if there's nothing
  to be saved
- Model selection dialog: ensure that the selected regressand is not
  also listed among the regressors
- Graph editing: make several more types of graph editable
- Graph saving: add PDF option if it's supported by gnuplot
- Main window: don't show generated lags in the list of variables
- ARMA: remove the ARMA item from the Variable menu (it's still there
  in the Model menu); revamp the X-12-ARIMA driver so it can handle
  models with exogenous regressors
- gretl graph page: add option to save as TeX source
- TeX: enable pdflatex and viewing of TeX output in PDF form (to use
  pdflatex, enter this as the name of the program to compile TeX
  files under /File/Preferences/General/Programs; this is now the
  default on Windows)
- Add "Send To" (email) functionality for data files and scripts
- "store" command: take file type from filename suffix for ".R" (GNU
  R format), ".m" (Octave format) and ".csv" (comma- separated)
- Add new "set" variable, "csv_delim", which sets the delimiter used
  when exporting data as CSV -- valid options are "comma" (the
  default), "space" and "tab"
- Add a new option for CSV export, "--omit-obs": suppresses the
  printing of a first column containing the observations
- X-Y graphs: display equation of fitted line when a fitted line is
  shown
- X-Y graphs: when fitted line is shown, add "OLS estimates" menu
  item to see details of the simple regression
- Graphs with labeled data-points: give option of showing all labels
  (for n < 55)
- Windows displaying two to five data series: add toolbar option to
  sort the data, with choice of variable by which to sort
- Test statistic calculator (Utilities menu): besides the entry of
  numerical values for sample statistics, enable the calculation of
  sample statistics based on selection of variables from the current
  data set, with or without sub-sampling restrictions
- Revamp the "online" (plain text) help system
- Split gretl manual into a User's Guide and a Command Reference and
  update both parts

2005-06-30 version 1.4.1
- Fix horrid unnoticed breakage in bhhh_max (broke both arma and
  tobit, big mess)
- Add utf8 validation/conversion for database descriptions (Banco de
  Espana databases)
- Allow dynamic forecasts with models estimated via corc and similar

2005-06-29 version 1.4.0
- Revise definition of functions in gretl scripts (a backward-
  incompatible change) in the interest of more structured programming
- Introduce named lists as a type that can be created and manipulated
- Big revamp of forecasting code.  Make forecasts available for all
  types of models; give a choice of static versus dynamic forecasting
  where relevant; make forecast standard errors available in more
  cases
- Increase max length of gretl script command line to 4095 bytes
- Add support for decennial data
- Fix for finding TrueType graph fonts on Windows 2000
- Add new "set" option: "horizon", to configure horizon for impulse
  responses in context of VARs; also add dialog box to set horizon
  for impulse response graphs in GUI
- Disable autocorrelation and ARCH tests in gui model test menu, in
  case of cross-sectional data
- Add Local Whittle Estimator for fractional integration, in context
  of periodogram command
- Add fracdiff function (fractional differencing) to the genr command
- sort function in genr: save sorted case markers if the dataset has
  case markers
- Bug fixes for data editing spreadsheet
- Another bug fix for the XLS importer
- In correlogram (acf) output, show calculated 5% critical value
- Correlogram: acf calculations should not use more than 20 percent
  of the available data by default (Tadeusz Kufel)
- Fix bug in Tobit command in the gretl GUI
- "omit" command: add asymptotic Wald test for joint significance of
  omitted variables, for estimators other than OLS
- ADF test: allow greater lag length if the data permit
- Add facility to import GNU Octave ascii data files
- Improvements to formatting in Spanish translation
- In statistical tables utility, add a bit more information for
  Durbin-Watson and improve formatting
- smpl --restrict: make it not an error if the restriction has no
  effect (drops no observations)
- Confidence interval for coefficients, GUI model menu: make
  available for all models
- Add matrix of actual and predicted outcomes to the printout of
  results for discrete models
- Improvements to many dialog boxes
- Numerous small bug-fixes

2005-03-14 version 1.3.3
- Add "poisson" command (thanks to Jack Lucchetti)
- Fix memory leak in VAR command with impulse responses, in the
  command-line program
- Fix bug: possible crash in "loop foreach" if an invalid variable
  name is given
- Fix bug: "display data" broken in gui program for long datasets
  ("press a key to continue" mechanism was invoked erroneously)
- Fix bug: wrong variable shown when you select "Display actual,
  fitted, residual" for a GARCH model
- Fix bug: hausman test for pooled model would crash if there were
  not sufficient degrees of freedom to estimate the group means model
- Fix bug: crash if default data and script files not installed with
  program (thanks to Ignacio and Dirk for finding this)
- Fix bug in genr: unary minus could be wrongly handled within the
  argument to a function
- Fixes for appending data (make more flexible: allow appending of
  observations and/or variables)
- Fixes for cointegration tests: improve dialogs and prevent crash on
  selection of just one variable plus the constant
- Fix naming of Mahalanobis distances variable
- Respect omission of constant from an ARMAX model
- Graph control dialog: add one-click option to force use of a single
  y axis
- New: in case of AR(1) estimation (Cochrane-Orcutt and similar), if
  a lagged dependent variable is included then we automatically use
  the procedure set out in Ramanathan, 5e, p. 450, to generate
  consistent estimates of the standard errors
- Fix: gui menu items for test of equality of means, with equal or
  unequal variances: these were hooked up in reverse
- corc, hilu and pwe AR(1) commands: make these available in loop
  mode
- add "quiet" option for the commands adf, kpss and wls
- add "simple-print" option for ols command (just print the
  coefficient table, with no auxiliary statistics)
- add "mahal" command: calculate Mahalanobis distances given a set of
  variables; also available in GUI via right-click popup menu when
  more than one variable is selected in the main window
- genr command: $nvars gives the number of variables in the dataset

2005-01-28 version 1.3.2
- Fix bug in auto-determination of lag in ADF test: was looking at
  the wrong coefficient in some cases
- Fix bug in VAR impulse responses: could get messed up by missing
  values that differ across series
- Fix bug: crash on generating LaTeX tabular output for a model
  estimated using robust standard errors (format string issue)
- Fix bug: the session "graph page" was not appearing even when a
  valid latex executable was available
- Fix bug: gretl console would not respond in case of an error when
  executing a command loop
- Fix bug: the "restrict" command failed in the GUI program when not
  applied to a named equation system
- Fix bug: printing "-inf" for AIC and BIC in case of a perfect
  linear fit
- Fix various issues in relaton to nested loops (for example, where
  the control variable for a given loop is not yet defined at compile
  time, but will be defined in an embedding loop)
- Fix sort-of bug: possible runaway generation of graphs in response
  to some loop commands
- Improve efficiency of test for existence of helper programs on
  Linux/unix
- Add auto-lag option to the GUI dialog box for the ADF test
- Remember the options selected in the ADF dialog from one invocation
  to the next
- Help files: include menu-path information in the GUI help file as
  well as the script commands help
- Provide a mechanism for retrieving the value and/or p-value from
  the last statistical test performed (via the special variables
  "$test" and "$pvalue" in genr)
- Perfect collinearity: try to detect this, and remove one or more
  redundant variables from the regression list if need be
- "label" command: if only a varname is given, print the variable's
  current label, if any
- "genr unit": generates an index variable for the cross-sectional
  units in a panel dataset (panel data only)
- Add "hurst" command (and GUI menu item) to compute the Hurst
  exponent (a measure of long-term persistence used by Mandelbrot)
  for a given series
- Remove unused GUI popup menu item "Simulate..."
- Updates to documentation (manual and helpfiles)

2005-01-19 version 1.3.1
- Add new dataset structure "wizard" in place of the old dialogs for
  setting frequency, starting observation and time-series or panel
  interpretation of the data
- Add FIML and LIML estimation to system command; also add LR
  over-identification tests for these systems
- Add Hansen-Sargan over-identification test for SUR and 3SLS system
  estimates
- Add "--iterate" option for estimation of systems via SUR and 3SLS
- Add "estimate" command for equation systems, and modify the
  "system" command to allow the user to define named systems
- Add gui configuration for robust standard errors options
- VAR dialog: add options for robust standard errors, and for the
  printing of impulse responses
- Add univariate kernel density estimation (under the Variable menu
  in the gui program -- no script counterpart)
- Purge the lesser-used model selection statistics, and use the
  original formulae for AIC and Schwarz's BIC
- Improve feel of data editing spreadsheet, gtk2 version
- Model dialog box: allow shifting of regressors with middle- click
  of mouse
- Add groupwise heteroskedasticity test for panel data
- Extend handling of missing observations in panel context, including
  case of unbalanced panels (to some degree)
- Fix for appending observations (built-in spreadsheet): plotting
  vars were not being automatically extended
- Fix for deleting variables: don't show the "variables have been
  renumbered" message if the only vars to be renumbered are hidden
  ones
- Fix newly introduced bug in time-series graphs: don't show two y
  axes if only one is actually used
- Fix for johansen cointegration test: don't crash if the user puts
  the const into the list of variables
- Fix bug in forecasts with standard errors, for case of missing
  observations
- Fix bug in reading of CSV files: crash if variable names were not
  found, but observation markers were found
- Add new option under Sample menu, "Transpose data" (for data that
  were read in "sideways" from, e.g., a CSV file
- Fix bug in ADF p-values for locales which do not use '.' as the
  decimal point
- Add BIC (Bayesian Information Criterion) to the list of model
  statistics that can be retrieved via genr (internal variable $bic)
- Add Baxter-King bandpass filter (bkfilt function in the "genr"
  command), thanks to Jack Lucchetti
- Add Kmenta (1986) dataset and script, for a further example of
  system estimation
- Add script to replicate Perron (1997) testing for unit roots with a
  structural break at an unknown point
- Add an emacs file, utils/emacs/gretl.el, offering an emacs major
  mode for editing and running gretl scripts.

2004-11-15 version 1.3.0
- add "append" command, to append data to the current dataset, as in
  the gui File/Append data
- add KPSS stationarity test ("kpss" command, Jack Lucchetti)
- fix bug: data importers were accepting duplicate names for
  variables
- XLS importer: handle string formulas; fix handling of large string
  tables (SST and CONTINUE records)
- fix bug: error in printing of model selection statistics for very
  large or small values on Windows
- fix bug in running scripts from the gretl console: file was not
  closed when an error was encountered
- fix bug in Prais-Winsten estimator
- fix bug in influential observations printout, for non- English
  locales
- revamp the Dickey-Fuller test functionality, with more options,
  clearer presentation (I hope), and p-values using James MacKinnon's
  code (JAE, 1996)
- fix panel data bugs: observation strings were broken for frequency
  greater than 99, and the "panel" command did not obey the
  "cross-section" option (thanks to Mihai Nica for the report)
- frequency plot, against gamma distribution: add Locke's
  nonparametric test for the null hypothesis that the variable in
  question is gamma
- add facility to generate cross-sectional unit dummies with panel
  data ("genr unitdum")
- add facility for nesting loops and fix some loop bugs
- fix some bugs in LaTeX equation display
- fix some breakage in online help system (e.g. for boxplots)
- add support for Latin 2 characters in gnuplot graphs
- add support for compacting daily data to weekly or monthly
- add support for daily data with a 6-day week
- fix for SUR systems with differing numbers of regressors across
  equations (thanks to Jack Lucchetti)
- improve convergence of GARCH function (Jack Lucchetti)
- make tobit command robust with respect to the scale of the
  dependent variable
- add stack() function to genr command: creates a stacked series from
  a comma-separated list of series, or a range of series as in
  stack(x1..xn)
- add a genr "special": genr markers = ... can be used to manipulate
  the observation marker strings -- details in panel.pdf
- support "genr varname[obs] = ..." for setting individual
  observations in a series
- Text/CSV data importer: handle calendar dates for non-daily data;
  handle description appended after the data
- add "vif" command to calculate Variance Inflation Factors for
  independent variables in a regression; also available in the model
  window under Tests/collinearity
- switch to St Louis Fed database as gretl "sample" database (the
  BCIH database is getting too out-of-date)
- add the Anscombe Quartet to the gretl data files
- add Mankiw, Romer, Weill (QJE, 1992) dataset and replication
  script, also Nelson and Plosser dataset
- on Windows, make EMF graphs respect the user's choice of plotting
  colors (required a modification to gnuplot)
- add option to save graphs in EMF format
- various minor gui fixes and enhancements
- update Windows version to glib 2.4.7 and gtk 2.4.13
- start adding user-defined functions
- add mechanism for customizing gretl's tex preamble

2004-07-23 version 1.2.9
- note: 1.2.8 was just a test release
- fixes for LaTeX printing of autoregressive models
- correct Spanish help strings
- fix font problem for some objects in session window
- fix for exporting time-series data to R version 1.9
- add option to export data to PcGive .dat format (thanks to Michal
  Kurcewicz)
- enable TRAMO analysis of annual time-series data
- Windows version: ensure user directory gets created!  This was
  broken in gretl 1.2.6 and 1.2.7, which could produce
  strange-seeming problems.
- hccm command: ensure that the F-stat shown for the model is based
  on the robust covariance matrix; also ensure the robust F-stat is
  used when robust standard errors are selected with the ols command
- add start-up option to dump gretl configuration to a text file
  ('-c' or '--dump')
- small fixes for nonlinear least squares
- Replace fixed IP address for database server with hostname
- Fix for copying material from gretl using Ctrl-C on Windows
- Update Windows version to gtk 2.4.3 runtime
- add "restrict" command for general Wald test of linear restrictions
  on a model
- add "ok(x)" as a short synonym for "!missing(x)" in the context of
  the genr command
- change smpl behavior: restrictions now cumulate by default
- add "smpl" option: "--replace" makes a sample restriction start
  from the full dataset rather than cumulating with any previous
  restrictions (note: this was the old default)
- another new "smpl" option: "smpl 100 --random" selects 100
  observations from the dataset at random
- allow the "--robust" option to the "var" command
- fix for effect of Up/Down keys in main gretl window
- gretlcli in batch mode: pass "#"-style comments through to the
  output
- fix HCCME bug: used way too much memory with large data sets
- add a new "set" option, "force_hc": if set to "on", then the robust
  option to ols always produces plain HC standard errors, not HAC (by
  default, HAC is used with time-series)
- profile and optimize some gretl_matrix functions
- allow specification of consecutive lags in a regressor list using a
  shortcut of the form "x(-1 to -4)"
- fix some subtle genr bugs, and some breakage in the nls command
  following earlier changes in genr

2004-06-13 version 1.2.7
- add Italian helpfiles (thanks to Cristian Rigamonti)
- update Spanish helpfiles
- add start-up option "-e" or "--english" to force use of English
  strings when LANG would indicate translation (also recognize
  environment variable GRETL_LANG: if this is "english" or "C", run
  in English)
- allow for missing values (silent) in audio graphs
- add a few keystrokes to the main gretl window: 'a': audio (read
  list of variables) 'x': stop audio 'e': edit attributes of current
  variable 't': plot current variable
- make start-up tests for tramo and x12a less verbose
- fix bug in deletion of scalar variables from the dataset
- fix bug in built-in spreadsheet: clicking in a blank column could
  crash gretl
- fix broken behavior of built-in spreadsheet for gtk 2.0.X versions
- fix various bug and typos in documentation
- build tweaks for OS X
- make available a pre-built disk image for OS X

2004-05-25 version 1.2.6
- add Hodrick-Prescott filter, as "hpfilt" function in the genr
  command
- revamp xls importer: should now be substantially more robust
- begin adding experimental audio graph feature for visually impaired
  users
- improve handling of non-ASCII characters in data files
- fixes for Spanish help files
- more fixes for build process
- GNU Octave data export: write all data as single matrix
- fix printing of "periods" in periodogram output (thanks to Tadeusz
  Kufel)
- fix generation of periodic dummy variables for daily data (again
  thanks to Tadeusz Kufel)
- with gtk >= 2.4.0 on Linux, use the new gtk file chooser
- update the Windows gtk version to 2.4.1

2004-05-04 version 1.2.5
- fix problem with acf and pacf calculations
- add Prais-Winsten estimator for AR1 models ("pwe" command)
- fix bugs in gretl "graph page"
- fix some translation bugs
- fix headers for compilation on Mac OS X
- fix bug in lmtest option handling
- make Excel importer a little more robust
- bug fix for saving data files with very large number of variables
  (tested with 548)
- bug fix for "diff" and "ldiff" commands with panel data in the form
  of stacked cross-sections
- plain text output: give option of copying as RTF (puts the output
  into Courier New at 9 points)
- in gui, disallow deleting variables when sub-sampled
- setobs command: be more flexible in regard to the format of the
  "startobs" field
- saving text files: try to improve handling of CR/LF
- minor fixes to model printing
- gnuplot fix: make copy-and-paste into Microsoft applications work
  again (this was broken by an MS security update of April 13, 2004)

2004-03-30 version 1.2.4
- Add ARMAX models: ARMA with exogenous variables
- Add GARCH models, using Fiorentini-Calzolari-Panattoni approach
  (Journal of Applied Econometrics, 1996)
- Add "resample" function to genr, for bootstrapping test statistics
- Loops: allow use of a variable name rather than a number to control
  a "number of times" loop
- Fix genr bug: problem with an undefined varname in a lag context
- Fix bug: when saved via the objectname mechanism, arma models were
  appearing both as saved models and as saved text
- Fix bug: autocorrelation test from model window Tests menu was
  broken by new options mechanism
- Fix bug: "--verbose" option for Johansen test was broken
- Fix curious Windows bug: line-endings in scripts were not
  recognized in some cases
- Improve path-searching for data files
- Beef up error-checking on opening of native gretl data files
- Improve error-checking on pvalue command
- Fix for Excel importer: allow more than 16K rows
- Error-checking for new varname in genr
- Add robust standard errors/VCV for tsls command
- Allow use of wls command in a loop
- CSV import: add automatic conversion of string variables to code
  numbers
- Add Three-Stage Least Squares (system type=3sls): this is still at
  the testing stage

2004-02-24 version 1.2.3
- Add Tobit model command, with a new plugin (thanks to Jack
  Lucchetti)
- Add color selector for the histogram in frequency plots
- Allow appending/merging of gretl-format data in GUI program
- Fix bug: genr was broken for some special cases of repeated
  function calls
- Fix bug: normal pvalues were being shown as zero for large
  |z-scores| > 9.0
- Fix bug: the NIST checker plugin was broken for locales that use
  ',' as decimal point
- Daily data: construct a special plotting variable so daily
  time-series can be graphed better; also allow for 4-digit years in
  daily dates (YYYY/MM/DD) on input; also fix "genr" so that dummies
  can be constructed as in "genr dum = t < 1987:10:19" (note that the
  slashes must be replaced by colons in this context)
- Text objects: in scripts and the gui console, many commands can now
  have their output diverted to a saved object (e.g. "ADF <- adf 1
  Ct"). As with models and graphs, these objects appear in the
  Session icon window, and they can be displayed and freed using
  objectname.show, objectname.free
- Make the model table available via script and gui console (new
  command "modeltab")
- Add "graph page" in session view: allows the user to create a page
  (which may then be viewed and printed) containing up to eight
  graphs (requires latex, dvips and a postscript viewer)
- Add an OLS option, "-r" or "--robust", which calls for the use of
  White's robust standard errors (HC0) in the case of cross-sectional
  data, or HAC in the case of time series data.  Details can be
  configured using the new "set" command.
- New command, "set", for configuring some program parameters via
  script or console
- Fix bug: latent problems when adding an observation to the working
  dataset
- Fix bug: set the frequency and starting observation could fail when
  the local decimal point is not '.'
- Fix: make the genr functions "coeff()", "stderr()" and "vcv()" work
  to retrieve statistics from ARMA models
- Fix bug: when appending CSV data to an existing dataset, could get
  uninitialized values at the end of the series
- Allow backslash-continuation of long commands in the gui console
- Updated help files and manual

2004-02-02 version 1.2.2
- Make AIC retrievable via genr ("genr foo = $aic")
- Fix brokenness in RTF printing/copying of ARMA models
- Add calculation of modulus and frequency for ARMA roots, and add
  printing of these to LaTeX and RTF output
- Fix bug in accessing critical values of F (Utilities menu)
- Add DFFITS values to the "influential observations" model test;
  also expand the help entry for this
- Add a little explanation of Johansen cointegration test results to
  GUI helpfile
- Fix bug: when you go to save data imported from gnumeric, the
  suggested file suffix should be changed to ".gdt"
- Fix bug: when importing data from Excel with a non-zero row offset,
  respect the offset when checking for date strings
- Fix bug: adding a variable to the built-in spreadsheet (GTK 2
  version) when there are already 6 variables shown
- Fix bug: handle quotation marks within descriptions of variables
  (XML encoding)
- Fix bug: bad behavior when you put an Excel file to open on the
  gretl command line, then cancel the import
- Fix bug: X-Y plot with "factor separation" went wrong in some cases
  (spotted by Ignacio Diaz-Emparanza)
- Fix bug: weighted least squares with a dummy variable for the
  weight crashed gretl when using QR decomposition
- Fix bug: a syntactically incorrect "genr" expression could lead to
  a crash (thanks to Steve Walesch for spotting this)
- Fix bug: set panel structure dialog very messed up in the gtk-1.2
  version of the GUI program
- Fix bug: Sorting variables by ID in the main window did not work
  correctly for more than 9 variables

2004-01-22 version 1.2.1
- Add Cristian Rigamonti's Italian translation
- More flexible and general support for collections of data files or
  script files
- Add support for the data files from Davidson & MacKinnon,
  Econometric Theory and Methods (ETM)
- Make the NIST linear regression test suite available via a plugin
- Add ARMA model to the variable menu (plus "arma" command) (thanks
  to Jack Lucchetti)
- Fix bugs with displaying a TSLS model in the GUI program
- Fix bug in display of actual, fitted and residuals in GUI program
- Fix occasional bug in copying data to clipboard as CSV
- Add a mechanism for configuring gretl as a networked application
  under Windows
- Small fixes for data importation
- Don't overwrite CSV datafiles with gretl format data
- Add a logistic model command and menu item
- Fixes for reading of recent RATS databases (thanks to John Frain
  for a useful bug report)
- Some updates to the manual and help files
- Enhanced LaTeX equation output (thanks to Alan Isaac for the
  suggestion)
- Fixes for several nameless bugs
- Various GUI tweaks

2003-12-14 version 1.2.0
- add "rename" command (rename a variable)
- add "printf" command for generating formatted output
- "delete" command: add the ability to delete specified variables,
  identified by name or number
- add "eval" command: syntax as in a "genr" formula; the result of
  calculation (or retrieval) is printed then discarded, not added to
  the data set as with genr
- Replace the internal workings of "genr" so that it can calculate
  dynamically (e.g. "genr y = .6*y(-1) + u"), which in effect makes
  the "sim" command redundant
- Make principal components analysis available via the GUI
- Improve formatting of descriptive statistics output when only one
  variable is selected
- Allow adding of "influence" values (calculated by the "leverage"
  test) to the data set in the GUI program
- When adding a variable to the dataset from a model window, give the
  user a chance to edit the name and description
- Windows: add option to emulate Windows look (via WIMP)
- add "--no-restore-data" to R invocation
- Fix for launching R from gretl on Windows XP
- Improve creation of time-series datasets for use in R
- Fix problems created by tabs in the command line
- Two-stage least squares: add list of instruments to printout of
  model results; fix crashing bug in printing covariance matrix of
  coefficient estimates
- Improve the mechanism for detecting the presence of a lagged
  dependent variable in a regression list; also show the
  Durbin-Watson stat in addition to Durbin's h when a regression
  includes a lagged dependent variable
- Fix bug in graph editing for non-English locales
- genr command: add facility for using date strings in boolean
  comparisons, e.g. "genr dummy = t > 1973:4" will work for quarterly
  data
- Allow '#' comments in loop constructions
- sim command: allow omission of starting and ending observations, to
  simulate over the full sample range; also allow the use of a minus
  sign to get the negative of a variable
- VARs: add facility to separate deterministic terms such as trend
  and dummies from the other variables in the regression list; add
  Durbin-Watson statistic to model printouts; add impulse responses
  and variance decompositions
- Improvements to data-editing spreadsheet in gtk-2.0 version
- New, improved dialogs for setting the sample range and sub-
  sampling using a dummy variable
- Add color selection to the graph editing dialog and improve the
  mechanism for selecting a graph font (only applies if gnuplot has
  the "new" PNG driver, i.e. gnuplot 3.8)
- Graphs: add option of removing the top and right border lines, if
  the graph does not have a "y2" axis
- minor fixes to the build process
- updates to gtk-1.2 GUI (make more consistent with the gtk-2.0
  version)
- Allow for renaming of saved session models and graphs in gtk2
  version of program
- Add a "lite" version of gtksourceview to the gtk2 source package
- Add recognition of dated daily data in importing from ASCII: dates
  must be like 89/12/31, i.e. YY/MM/DD
- Loops governed by a convergence criterion: set a failsafe maximum
  number of iterations, namely 250.  This can be altered by setting
  the environment variable GRETL_MAX_ITER
- Update to gcc-3.3.1 and mingw-runtime-3.2 for Windows build

2003-10-31 version 1.1.6
- Test release for Fedora (Linux) packaging

2003-10-24 version 1.1.5
- Updates to manual
- Gtk2 version: Make selection dialog tall enough for wls, tsls and
  ar model selections
- Model window, graph menu: if there are two independent vars, offer
  the option of a 3D fitted/actual plot
- Set sample range: in this dialog, give as default the current
  sample range, not the full data range
- When a session uses data imported from a database, be smarter on
  saving the session: ensure the script includes a command to open a
  datafile (get this saved first if need be)
- Database browser window: close this when a database is selected
- GUI model windows: allow drawing of graphs relating to model data,
  even if the sample has been changed since the model was estimated
- Model table: make a LaTeX preview available
- Windows installation: fix typo in name of uninstaller program in
  the Programs menu
- Windows version: bug fixes and enhancements for gretl_updater, and
  add a simple logging mechanism to aid in trouble-shooting
- Windows: add the ability to print a gnuplot graph directly
- ols command: add '-q' (quiet) option to suppress printing of
  results (and add notice of this to gretlcli.hlp)
- Consolidate "webget" code -- one version for all uses
- gtk2 version: replace "system()" calls with g_spawn()
- Add model selection statistics to output of adf command
- Improve recognition of dated data when importing from Excel or
  Gnumeric
- Add an error message for an attempt to run TRAMO when the sample
  size is > 600
- Fixes for reading of plot range info in graph window in non-English
  locales

2003-10-06 version 1.1.4
- Make auto-entry of varname for sampling with dummy smarter
- Fixes for display of data values with huge datasets
- Fix to handle "weird" cases in plotting frequency distributions
- Auto-detect gnuplot's ability to use "filledcurve" style
- Translate a few untranslated strings in gtk-1.2 version
- Graph labels: make 3 labels configurable rather than just 2
- Editing gnuplot commands: fix for accented characters
- Reading CSV files: fix bug in parser for date strings
- NLS: ensure messages printed to the console are not in utf8
- Loosen up a little on "Appending" data: allow for the situation
  where the sample range for the added data is not identical to the
  original range
- Fixes for printout of fitted, actual and residual, and for
  forecasts with standard errors, in the case of missing data
- Fix to gtk2 data spreadsheet (quell warning on appending an
  observation)
- Data spreadsheet: give a warning on close if there are unsaved
  changes
- Improvements to printing of data values in certain numerical ranges
- Import of CSV or plain text data: if no variable names are given,
  construct them automatically ("v1", "v2", etc.)
- 3-D plot command: fix for localized decimal point, and use rxvt to
  control gnuplot if xterm is not available

2003-10-01 version 1.1.3
- Fix crashing bug in viewing dataset info
- Improve formatting of "influential observations" test output for
  non-English locales
- Correct the sign of the fractional integration parameter estimate
  in the periodogram command ("pergm")
- Give first-time gretl users a chance to select a gretl "user
  directory" (with ~/gretl being the default)
- Fix problem with running a script in the gretl console, when the
  script begins with comments plus blank lines
- Brighten up some menus with stock icons (gtk2 only)
- Use gtksourceview to do syntax highlighting for scripts (gtk2
  version only)
- Change function of main-window toolbar edit icon: from launch an
  external editor to start a new script
- Fix bug in meantest command: the -o flag was doing the opposite of
  what was stated in the manual
- Fix bug in built-in spreadsheet in re. adding variables or
  observations
- Ensure that the listing of variables in the main window is updated
  after running a script
- Add facility to exclude named observations with smpl command (e.g.
  smpl -r obs!="USA")
- Add "nobs()" function in genr: gives the number of valid
  (non-missing) observations for a data series
- Improve placement of observation labels on graphs
- Improvements to gnumeric data importer
- Add facility for generating 3-D data plots
- Add "import ASCII" data option

2003-09-09 version 1.1.2
- Fix bug in time-series plot from popup menu in main window
- Fix build problem: "make install" could fail to install the GUI
  program under some conditions (thanks to Dirk Eddelbuettel for
  spotting this)
- Update the Spanish translation
- Win32 version: switch to the native Windows font selection dialog
  box (some problems were reported with the modified gtk font
  selection on win32)
- Win32 version: update to gtk 2.2.4 and pango 1.2.5
- Library: switch to using the Cephes gamma() code throughout, and
  delete some redundant code

2003-09-07 version 1.1.1
- Graph editing: add facility to write labels onto the graph
- Graph editing: allow removal of auto-fitted OLS line
- Graph editing: allow choice of TrueType font if gnuplot supports
  this option (requires libgd and freetype)
- Add compaction method (e.g. average, sum) as an attribute of
  variables -- settable under Variable/Edit attributes
- Add "outfile" command to send output of selected commands to a
  specified file
- In importing data from a database, recognize if a variable of the
  same name is already in the working dataset
- Fix memory bug in opening remote database
- Start adding Principal Components Analysis
- Fix "pmax" bug in printing of actual, fitted and residuals
- When using "<-" save mechanism for models, preserve the model info
  so it's accessible for genr, etc.
- Fix bug in numbering of auto-generated lagged variables
- Fix bug in parsing of gnuplot { ... } special command list
- Fix bug in model table (wrong coefficient numbering)
- Fix bug: when a file is dragged onto gretl, opening the file failed
  if it has a space in its name
- configure: require correct version of GMP (>= 4.0.1)
- Fix bug: gretlcli.exe on win32 didn't find user directory
- Workaround: command-line invocation of gretlw32.exe with datafile
  could crash (I think this was a Windows bug)
- Fixes for forecast-with-errors graphs
- Fixes for "influential observations" test calculations, in extreme
  cases
- Windows version: update to gtk 2.2.3 runtime

2003-07-23 version 1.1.0
- Extend DATAINFO structure -- allow specification of "display names"
  for variables (these are shown in graphs)
- Provide "label" command for setting the description and/or display
  name for a variable
- Add script commands for saving and displaying models and graphs
- Fix effect of sample range on the "genr" command
- Improvements to the gretl console (command history, etc.)
- Add the Johansen cointegration test to the gui menus
- Add option to use QR decomposition instead of Cholesky for
  calculating regression results
- Fix bug: periodogram command failed in batch mode
- Make uniform() PRNG generate in the standard range 0-1 (rather than
  1-100, as it was previously)
- Small modifications to path-searching
- Updates to the Spanish help files
- Activate a few missing translated strings
- Fix "sim" command so it can be used to modify just one observation
  in a given series
- Fix bugs associated with starting a dataset by importing from a
  database
- Allow access to RATS databases via command line and scripts
- Fixes (I think) for R startup
- Clean-up: remove all wasted array elements
- Update to libtool 1.5
- Update win32 version to gtk version 2.2.2

2003-05-26 version 1.0.9
- Add non-linear least squares ("nls" command, Levenberg- Marquandt
  algorithm from minpack, with either analytical or numerical
  derivatives)
- Fix focus bug when editing the description for a variable in the
  gretl main window
- Add a new means of grabbing fitted values from a regression: "genr
  newname = yhat" (parallels "uhat")
- Updates to manual (includes details on new nls command)
- Spanish version: provide access to English help files as well as
  Spanish
- Add rudimentary scripting capacity to gnuplot command (can append
  "{ ... }" block to gretl gnuplot command, containing literal
  gnuplot command lines, each terminated with ";")

2003-05-02 version 1.0.8
- Require lapack
- Fixes to build for Mac OS X
- Avoid duplication of "against time" in model graph menus, when time
  is included as a regressor
- Fix bugs in Find dialog
- Correct function that detects whether or not series should be
  scaled for time series graphing (case of negative values)
- Fix bug in boxplots with boolean conditions attached
- Ensure all plot windows are not resizable
- Add "leverage" command (uses lapack) to detect leverage points and
  influential observations for a given model
- Fix "diff" and "ldiff" commands for panel data sets (i.e. show
  missing values as missing)
- Fix bug in editing of varnames and labels (could get onto the wrong
  line in some cases)
- Fix gretl's startup routine for Gnu R so that it never over- writes
  the file .Rprofile
- Enhancements to Excel importer plugin (better warnings)
- Permit opening Excel or Gnumeric data from initial command- line
  invocation of gretl
- Autocorrelation test: add calculation and display of serial
  correlation-robust standard errors, if significant at the 5 per
  cent level
- Fix brokenness in saving boxplots to session file
- Refinements to CSV import function -- handle space-separated data
  with multiple/variable spaces between columns
- Fix bug in range-mean graph when there are missing values at the
  start of the data range
- Fix bug in pacf calculation and plot for long lag lengths
- Add experimental "model table" in session icon view (not submitted
  for translation yet)

2003-04-09 version 1.0.7
- Correct the attribution of autocorrelation test (Breusch-Godfrey
  rather than Breusch-Pagan)
- Fix bug in display of remote database info line (Gtk-2.0 version)
- Use a finer step-size for Hildreth-Lu search
- In GUI program, display Hildreth-Lu plot using gnuplot
- Translate a few more untranslated strings
- Fix bug in title of residual graph
- When the user installs a local copy of a remote database, give the
  option of opening it right away
- Add "coeffsum" command: gives the sum of coefficients, and standard
  error of the sum, for selected independent variables in a given
  model
- Modify the White's test function, so that it doesn't fall over when
  a variable and its square are among the original regressors
- Fix drag and drop of data files and script files from desktop or
  file manager onto the main gretl window
- Add drag and drop of data series from a database window into the
  main gretl window (i.e. into the current data set)
- Add general time-series data compaction function (under Sample
  menu)
- Fix various memory-usage bugs revealed by port to Mac OS X
- Fix installation of bcih database so that it works on big- endian
  machines too

2003-03-16 version 1.0.6
- minor adjustment to model print output formatting
- fix for correlogram graph (was incompatible with older gnuplot)
- fix a couple of minor gretlcli bugs
- add (optional) LAPACK support for various "advanced" features
- fix time-series attributes of data9-1, data9-10
- prevent normal random generator from outputting NaNs
- fix bug with use of "store" command in a loop, in GUI program
- fix translation problems that disabled some menus when not shown in
  English
- fix translation problem that caused a crash when trying to save
  data under a different name in non-English versions on Linux
- add new commands, "system" (supports SUR) and "coint2" (Johansen
  trace test for cointegration)
- add robust LM test for use with adding/omitting variables in
  relation to a model estimated using hccm
- permit comments starting with '#' on first line of script
- change to Mersenne Twister for gretl's PRNG, and supply the
  Marsaglia test suite for the PRNG in the gretl source package
- make correlogram and periodogram functions more robust in the face
  of weird data

2003-02-20 version 1.0.5
- fix missing translations; fix build of rpm
- add support for Gujarati textbook data files

2003-02-19 version 1.0.4
- add sst() function in genr for Total Sum of Squares of a variable
- fix bug in genr: a long genr command could overflow the space
  allocated for variable labels
- fix bugs in graphing: "non-standard" graphs could cause problems
  including crashes
- fix bug in coefficient printing: sometimes values were being
  truncated at 5 figures
- when dataset is sub-sampled, add dialog offering option to restore
  full data range before saving data
- add recognition of environment variables GRETL_PNG_GRAPH_FONT and
  GRETL_PNG_GRAPH_FONT_SIZE (e.g. "verdana" and "8") for generation
  of PNG graphs when gnuplot is linked to gd, and gd has TrueType
  font support enabled
- The sample data files selector and practice scripts selector now
  offer a tabbed collection of the available sets of files, and the
  associated menu items are simplified
- Replace Box-Pierce statistic with Ljung-Box throughout, and revamp
  the correlogram graph
- Add several configuration options to the tramo/seats plugin
- update libtool to 1.4.3 and autoreconf
- raise library revision number to 4

2003-02-04 version 1.0.3
- Add PNG graphs to win32 version, and standardize on PNG graphs for
  all display including graph editing
- Add facility to identify labeled data-points in a scatter plot
- further fix to pathnames with .Rprofile for win32
- LaTeX view: fix for dvi file living in a directory with spaces in
  its name on win32
- Add option to copy as LaTeX or RTF for the various "Model data"
  windows (e.g. forecasts with standard errors)
- Reorganize management of win32 registry entries
- Add tramo/seats for win32 version, and make tramo support the
  default for Linux
- In window displaying a single data, add menu options to show the
  series sorted, to graph the variable, and to format the data values
  to a specified number of significant digits or decimal places
- Fix bug in command echo for "store" and a few others
- Add selector for variables to be saved when doing "Save as" or
  "Export"
- Add facility to browse for programs under the Preferences, General,
  Programs tab
- Add facility to copy data to clipboard as CSV
- Update win32 version to gtk version 2.2.0
- Bring various details of the gtk-1.2 build in line with the gtk-2.0
  version
- Add configuration option to avoid libreadline dependency
  ("--without-readline") and build the gretl rpm without readline
- Updates to manual
- Raise shared library revision number to 3

2002-12-09 version 1.0.2
- generalize support for X-12-ARIMA to gtk-1.2 version, and win32
  version (TRAMO/SEATS proving is more difficult)
- make x-12-arima support the configure default, if the x12a binary
  is found
- add installation script for tramo program (in utils)
- make range-mean graph editable via gui
- fix utf8/character encoding issue with editing gnuplot commands and
  sending the commands to gnuplot
- fix bug in test for balanced panel and reading of panel structure
- panel models: implement a valid autocorrelation test, and make the
  ARCH test unavailable
- fix bug in generating lagged variables with panel data
- put a limit of 1024 on the number of forecasts that can be called
  for, in the "forecast with standard errors" routine (could exhaust
  virtual memory)
- add menu item to restructure a panel data set from stacked
  cross-section to stacked time series
- create data set using internal spreadsheet: fix bug in the setting
  of date strings
- fix bug in invocation of GNU R under Windows (needed to replace "\"
  with "/" in paths for use by Rgui.exe)

2002-11-27 version 1.0.1
- fix to configure script in re. glib-2.0
- fix missing name of dependent var in gui mpols printout
- remove RTF and LaTeX items from mpols copy options (not yet
  implemented) in gui2
- fix bug in saving gnuplot commands to file
- updates to updater function in gui program (both gui and gui2)
- add rudimentary plugin support for TRAMO and X-12-ARIMA
  (experimental, and disabled by default)
- fix font encoding for postscript graphs in gtk-1.2 version of
  gretl_x11 (also make postscript graphs in color by default)
- fix bug in automatic generation of lags for regression (the command
  was not getting recorded properly in the log file)
- fix bug in model printout when F() is undefined (line-break was
  missing)
- fix bug in LaTeX output when a coefficient equals zero
- make "sim" command available in loops (and update docs)
- raise "revision" number of *nix library

2002-11-15 version 1.0
- change *nix library name to libgretl-1.0
- improve sizing of some windows
- incorporate new translations
- update appearance of gtk-1.2 version of gui
- fix the stats available in connection with a LAD model
- open the champagne (hope this is not premature!)

2002-11-06 version 1.0pre4 (for translators)
- fix bug in progress bar when loading large data set
- fix bad "smpl -r" bug in gretlcli
- add Ramsey's RESET test (command "reset")
- improve consistency of editing commands
- more translation fixes
- small LaTeX output fixes
- fix gnuplot PNG output for gnuplot version 3.8
- fix encoding for gnuplot postscript output under NLS
- fix pango encoding issue for gnuplot axis label strings
- fix gnuplot "keyspec" bug
- add auto-scaling of gui windows if the user has selected a large
  font
- add printing of rho (used in quasi-differencing) to LaTeX output
  for corc and hilu models
- enhanced support for Wooldridge data files
- add "-t" flag to print command: print variables to ten significant
  digits
- improve saving of scalar variables, and documentation of same
- updates to full manual
- make names and labels for monthly and quarterly dummies more
  descriptive

2002-10-10 version 1.0pre3
- improve accuracy of calculation of standard errors, and numerical
  accuracy on MS Windows in general
- make gretl databases installable in user directory as well as
  system database directory
- make console output scroll to cursor in gtk2 version
- fix more translation issues
- fix bug in normality chi-square test for large n
- fix bug that prevented CUSUM plot from displaying
- fix normality of residual test: print to model window was
  incomplete
- fix translation issue in LaTeX print of equation
- backport fix for impulse plot to gtk-1.2 version
- fix bug at exit of gretlcli with "quit" and no filename
- fixes for bugs in gnumeric file reader
- fixes for Excel reader -- handle missing obs and Far East info
- fix for gretlcli under NLS: ensure that the translations come out
  in the local encoding, not utf-8
- remove Gtk 2.0 right click menu on text windows
- update translations and integrate the French translation

2002-09-20 version 1.0pre2 (pre1 was "for translators only")
- add range-mean graph option to GUI Variable menu, and as new
  command "rmplot"
- add retrievable variable $pd = data periodicity
- add min() and max() functions to the functions available for use
  with the "genr" command
- add Least Absolute Deviations regression ("lad" command)
- fix bugs in saving output to named file, in both gretlcli and gui
  program
- fix bug in boxplots for languages other than English
- fix error in df in sample script ps4-2.inp
- fix translation of date strings in gretl output
- linux: move plugins to ${prefix}/lib/gretl
- gnome 2.0: use gconf apparatus
- gtk 2.0: fix remove/add toolbar breakage; change name of program
  back to "gretl" and "gretl_x11" (not "gretl2", "gretl2_x11")
- revamp and internationalize TeX and RTF printing functions
  including those for summary stats and correlation matrix
- make TeX format available for all model windows
- remove HTML print/copy options: can't maintain four formats with
  internationalization!

2002-08-25 version 0.999
- add support for gtk 2.0 and gnome 2.0
- enhanced gui with gtk 2.0
- add "make check" target to test against the NIST reference data
  files for numerical accuracy
- improve support for building on win32
- bug fixes in boxplot functions
- always show 6 significant figures for coefficient estimates and
  standard errors in regression output
- numerous NLS/translation fixes, improvements
- NLS translation of TeX model results
- bug fixes for Excel importer
- reorganization of gui source files
- fix bug in random variable generation in gui
- add support for data files from Jeffrey Wooldridge's econometrics
  textbook
- scrap ugly overloading of "clear_model" function
- fix miscellaneous bugs revealed by valgrind
- raise library version to 16.0.0

2002-07-09 version 0.998
- increment library version to 15.0.0
- update Spanish translations
- fixes to RPM build process
- switch to more accurate (cephes) algorithms for p-values
- add materials for building gretl on win32
- try to support LC_NUMERIC conversion automagically
- add option to Preferences to enable/disable localized LC_NUMERIC
- fix listings of recently opened files on menus under NLS
- fix up formatting of fitted/residual printout
- activate translations of "session" popup menus
- extend LaTeX menu for models with choice of saving as full document
  or tex fragment for inclusion in document
- correct over-eager rejection of some variable names in data files
  ("c" and "C")
- recompile gretl_updater.exe with new zlib dll
- fixes to graph editing (this got broken by NLS changes)

2002-05-28 version 0.997
- increment library version to 14.0.1
- NLS fixes: disable "foreign" LC_NUMERIC for the present; gnuplot
  graphs should work now; some missing translations are activated;
  minor formatting improvements
- screen scalars out of variable list in graph selection dialogs
- ensure appropriate headers are included in workbook.c
- enable daily data in gretl databases
- fix bug in daily calendar (printed dates wrong at end of some
  years)
- portability fixes to configure script

2002-05-24 version 0.996
- Raise library version to 14.0.0
- closing a session clears the selector dialog presets
- fix bug with scalar data and the data-editing spreadsheet
- revert boxplots to the older selection dialog (so user can add
  boolean conditions)
- Regressions: print warning when data matrix is close to singularity
- add Gnu Multiple Precision plugin for running multiple precision
  OLS regressions (unix only, so far)
- Add Spanish translations and make enabling NLS the default
- Try to fix the win32 GUI font for high-res monitors
- tweaks to the configure script
- updates to the help files and manual

2002-05-15 version 0.995
- Raise library version to 13.0.0
- numerous small updates to facilitate internationalization
- give the user a choice of delimiters (comma, space or tab) when
  importing or exporting "CSV" data
- strengthen checks on invalid variable names in data files
- improve recognition of scalars versus vectors in genr
- fix bug in Create Dataset: undated data appeared as "annual"
- add descriptive report on dataset to Data menu
- fix bug in writing Utilities/R session: R data set was being
  written in wrong (CSV) format
- fix bug: datafile name was not being cleared on Close Session
- refinements to Makefiles: don't expand CFLAGS multiple times
- handle spaces in filenames when stacking the "open" command
- fix bugs with editing gnuplot graphs
- get win32 LaTeX view working properly
- bugfixes for gnumeric and excel spreadsheet importers
- bugfix: unitialized data in cointegration test with constant
- add new, improved dialog box for specifying models, etc.
- remove all system() calls on win32
- switch to a more "standard" (I think) presentation of WLS
  statistics
- fix some subtle bugs with the genr() function (scalars versus
  vectors in conjunction with sub-sampled data)
- add checks for illegal variable names when importing from CSV,
  Excel and Gnumeric

2002-04-21 version 0.994
- fix bugs in win32 copy to clipboard
- fix RTF printing of correlation matrix
- fix bug in genr (generating a scalar when data set is sub- sampled)
- fix bug: editing periodogram graph using GUI
- partially update docs
- distinguish between $T (number of obs used in last model) and $nobs
  (number of obs in current sample range) in genr expressions
- fix bug in gnuplot PNG display for remote X sessions
- add configure option "--disable-png-graphics" to revert to
  old-style behaviour of gnuplot in case of problems
- remove upwanted dependency on libgcc_s in Red Hat binary rpm
- update versions of gtk and glib for win32
- fix build problems revealed by the Debian package build

2002-04-15 version 0.993
- add option to specify lag order in autocorrelation test; also add
  Box-Pierce and Ljung-Box stats to test output
- fix brokenness in Excel importer on win32
- fixes to setmiss command (console and script modes)
- enable pop-up menu for all gnuplot graphs under Linux/unix; also
  add facility to print graphs directly under gnome, and to zoom
  graphs on X11 display
- make DVI viewer configurable and make "latex view" functions work
  on win32
- add inclusive inequality operators '>=' and '<=' to genr
- fix bug in genr: operator priority was not being fully respected in
  all cases
- fix bug in Replace function for script edit window
- fix bug that crept in, in reading old-format data files
- fix bug: possible loss of precision when writing data file
- fix bug in statistical reportage with weighted least squares, when
  the weight is not a dummy, but has some zero values
- add if, else, endif flow control for scripting
- add noecho command to suppress echo of commands in script output
- modify "print" command to support printing of string literals
- add menu item to find a variable in the main window
- improve context help in script windows
- extend LaTeX printing of models to Cochrane-Orcutt and Hildreth- Lu
  estimators
- add edit/print taskbar to more windows

2002-04-01 version 0.992
- bounds checking for critical values look-up; also add this as a
  regular gretlcli command, "critical"
- add sanity checks for regression commands and ADF test
- add importer plugins for Gnumeric and Excel workbooks
- add "Append data" menu item
- fix bug in "Create data set" functions

2002-03-20 version 0.991
- fix several "out of bounds" bugs kindly reported by Tavis Barr
- streamline the online help system
- in GUI, allow deletion of any variable (popup menu)
- go to a two-dimensional data array
- get the data status indicator working better when the nulldata
  command is used
- add menu items to set missing value codes for a particular series
  or the entire data set, and add "setmiss" command
- changing or clearing the data set now closes all model and stats
  windows (prevents crashes and garbage)
- add scalar datatype
- add progress indicator for reading/writing large data files
- add a refresh to the remote databases window after down- loading
  and installing a database
- add handling for daily data (probably needs more work)
- update to gnuplot 3.7.2 in win32 distribution
- prepare the program sources for internationalization via GNU
  gettext; add a blank .pot file to the source package

2002-02-27 version 0.99
- add option for HTTP proxy when contacting gretl data server
- fix bugs in drag and drop under Windows
- fix crashing bug when trying to save a data file with over (about)
  120 variables
- fix bug in editing new data header info
- add mechanism to record sample when estimating a model, so that
  subsequent tests on that model can be referred to the same sample
- add "native" printing of window contents under win32 and gnome
- enhance boxplots command, allowing for boolean expressions to limit
  the sample for individual plots in a comparative group of plots
- add editing toolbar to editable windows with search/replace and
  undo
- add context help (click on a command and press the "?" button) for
  the edit command script window
- correct typos in supplied data files data3-2 and data8-3
- add "critical" command (gretl console and GUI script mode only), to
  print critical values for a selected distribution
- add pvalue() function to the set of options available under the
  genr command
- improve handling of scripts opened in the GUI (including a prompt
  to save before running if changes have been made)

2002-02-11 version 0.98
- fig bug affecting frequency distributions and the test for
  normality of residuals
- improve functionality relating to saving of data files
- fix some build problems
- add more functionality to boxplots
- several fixes and enhancements to "session" mechanism
- better handling of empty data header info
- substantial code cleanups in the interest of adding API
  documentation
- allow copying LaTeX equation representation of models to clipboard;
  also improve the typsetting of these
- change default user directory to ~/gretl under unix
- add option to make cwd rather than userdir the default for file
  opening and saving
- Change the default data format to XML (optionally gzipped) but
  retain backward compatibility with old ascii data format
- add dependency on libxml (dll suplied for win32)
- switch from ".dat" to ".gdt" as default filename extension for
  gretl datafiles (but add option to GUI to use ".dat")
- changing to storing data header info in buffer rather than using
  repeated file I/O
- add search/replace dialog to window for editing scripts; also
  Edit/Paste menu choice and choice of fixed font
- add drag and drop support for datafiles under win32, register the
  .gdt suffix for gretl datafiles, and add an icon for these files

2001-12-14 version 0.97
- fix breakage of var command in GUI
- add facility to draw boxplots
- add various formats to copy of models to clipboard (HTML, RTF,
  LaTeX)
- enable LaTeX and RTF copying for correlation matrix and summary
  statistics windows
- Add the LMF statistic (Kiviet, 1986) for the autocorrelation LM
  test
- Add prompt to save data on exit, if the data set has been changed
  or newly constructed
- Fixes to BOX1 datafile reading function
- small fixes to display of databases
- revert behavior in case of taking logs of series with non- positive
  values (i.e. fail gracefully)
- add initial gnome support
- convert manual to SGML (DocBook) and update
- support directory names with spaces (yuck) under win32
- under win32, use registry instead of system-wide config file
  libgretl.cfg and per-user gretl.rc; also use native win32 dialog
  boxes for more functions
- add check for GRETL_HOME environment variable
- make gnuplot command configurable under Preferences (meant for
  win32)
- add a menu bar to the spreadsheet window

2001-07-26 version 0.96
- update to gtkextra version 0.99.16
- fix bug in Preferences/Toolbar entries

2001-07-17 version 0.95
- update to gtkextra version 0.99.15
- fix crash bug on opening a saved "session"
- fix bug that broke the "run" command on win32

2001-06-14 version 0.94
- make "false" the default for the automatic gretl update query on
  startup
- catch errors in ar, tsls and scatters commands due to insufficient
  arguments

2001-05-11 version 0.93
- fix problem with printing of actual, fitted and residual in the
  case of a binary dependent variable
- CVS data export: put quote marks around the dates or observation
  marker strings

2001-04-23 version 0.92
- library version goes to 6.0.0
- fixes to pprintf() function
- add "pooled OLS" model command and panel diagnostics test (fixed
  effects and random effects models)
- various fixes suggested by lclint
- fix bug with zero return from, e.g., auxreg() when there's an error
  and the return should be non-zero
- fix bug: logs command in script mode producing spurious error
- fix bug: when starting a new data set from a gretl database,
  datainfo->markers was not set to 0, which could produce a crash
- add options for compacting data when adding a higher-frequency
  series from a database to the working data set

2001-04-03 version 0.91
- library version goes to 5.0.0
- Disable saving anything other than native data file with extension
  ".dat" (safety measure)
- Make backup of data file when saving under same name
- Further improvements/fixes to gnuplot graphing routines
- Add option to edit plot commands directly, for a graph saved as a
  session icon
- GNU R: save cross-sectional data as a "dataframe"
- Remove the "with controls" gnuplot menu items: edit plots via the
  session window instead
- Institute consistent file dialogs: using gtkextra under X, and
  native Microsoft dialogs under Windows
- Bug fix in pprintf() function

2001-03-28 version 0.90
- Raise version number to 0.90 reflecting fact that the feature set
  for version 1.0 is now complete
- Raise library version to 4.0.0 due to changed interfaces
- Bugfixes and improvements for built-in spreadsheet
- Make more statistics accessible under model data menu
- try to auto-detect script versus data file, when given one program
  argument and no flag
- add gretl_model_new() to lib
- cleanups in library code and headers
- enable frequency plot graphs in console mode
- add command-line options (for GUI program) to open a gretl database
  on start-up.
- add "t" facility to genr (can say, e.g., "genr dum = t>1979.4" for
  quarterly data, without previously generating t).
- add "for loop" facility with auto index variable
- auto-save changes to scripts in file viewer windows before running
- TODO: manual is not fully updated yet

2001-03-16 version 0.70
- Changed a few library interfaces, and so raised the library version
  number (now 3.0.0)
- update manual (please consult it on the new options below)
- add sub-sampling based on a boolean condition (smpl -r)
- make it possible to restore full sample after sub-sampling based on
  a dummy variable or boolean condition
- add graphing option: scatter of Y against X, with the Y values
  colored differently depending on value of a given dummy
- suppress echo of varnames in commands (e.g. summary) where a full
  list of vars is constructed automatically
- improve mechanism for adding/deleting files from "recent files"
  lists, and add list for command files
- improvements to numerical format in printing of data series
- fix a couple of graphing bugs (impulse plots not working, frequency
  plot against gamma distribution wrong)
- fix precedence of boolean operators in genr expressions ("&" comes
  before "|", but both of these come after "<", ">" and "="), and add
  "!=" operator
- mods to gtk items: disallow resizing of dialog boxes, make clist
  titles passive
- fix "on exit" bug if several models estimated and not all have
  associated saved commands
- fix memory bug when switching datasets
- fix issues with displaying data, with very large datasets

2001-03-04 version 0.69
- change one library interface to permit error box if gnuplot command
  fails (and so raise library version number)
- bugfix: after running lmtest for non-linearity, the wrong degrees
  of freedom were being shown, not in the auxiliary regression
  window, but in the test summary appended to the model for which the
  lmtest was run
- bugfix: with a genr command from the GUI, even if it was erroneous
  it was being copied into the command log
- bugfix: parsing of genr expression without fully explicit
  parentheses failed under some circumstances
- bugfix: multiple scatterplots did not display under MS Windows
- bugfix: doing add/omit in GUI did not update the model used as the
  default for coeff() and such in genr commands
- console: improve/fix recall of mistyped command using the up arrow
  key; respond to typing only at the prompt
- genr: add '&', '|' and '!' logical operators
- add program icon for X11

2001-02-26 version 0.68
- fix functions associated with opening datafiles
- fix brokenness in logging of commands to script
- "remember" models generated via GUI so that genr functions such as
  coeff() work properly
- make Save/Export data menu items more compact
- Fix bug in (not) setting file extensions in some file "save"
  actions
- Small improvements to "gretl console"

2001-02-21 version 0.67
- cleanups in datafile writing routines (avoid excessive trailing
  zeros in data)
- make search in list boxes wrap
- fix bug: user configuration of toolbar had no effect
- fix bug: if a var is duplicated in list of regressors, gretlcli
  crashed
- fix infelicity: if a var is duplicated in regressor list, gui
  displayed blank model window along with error message
- fix bug: "gretl website" entry on toolbar under unix/Linux worked
  only if netscape was already running

2001-02-15 version 0.66
- add string search to listing of Ramanathan data files
- add "plugin" for looking up critical values of statistics
- add a toolbar (partly configurable under Preferences)
- fix to deletion of auto-generated plotting vars
- add option to view confidence intervals for coefficients (under
  Model data menu in model window)
- add the Ramanathan practice file ps2-1.inp

2001-02-06 version 0.65
- fix crashing bug in adding data to dataset from model window
- update bundled gtkextra to release 0.99.13
- various "internal" bugfixes and cleanups
- minor fixes to graphing routines, datafile saving

2001-02-02 version 0.64
- add tooltips to show full path of previously-opened files
- get "previous files" list working on win32
- minor improvements to file listing routines
- add (optional) sampling distribution graph to test calculator
- add -m (impulses) flag to gnuplot command
- fixes to auto-update mechanism (plus add documentation)

2001-01-26 version 0.63
- add gretl manpage
- add p-value finder to GUI
- add "hypothesis test calculator" to GUI
- fix error in normal batch p-value function

2001-01-15 version 0.62
- allow comment lines starting with '#' in input files
- allow estimation of a model with df = zero
- add CUSUM (parameter stability) test for OLS models
- fix to path reading for win32 (spaces in path)
- fixes to difference of means test, difference of variance test, for
  situation where sample lengths are different
- small fixes to manual

2000-12-09 version 0.61
- fix to configure process for gtkextra

2000-12-08 version 0.60
- various fixes to distribution files
- change default user dir to $HOME/.gretl
- fixes to icon file selector
- basic link to GNU R
- revise PDF manual
- revise "scatters" command (multiple scatterplots) and add to gui
- add read/write of gzip-compressed data files (see store command)
- move descriptions of data files and practice scripts into separate
  files (no longer hard-coded into gretl)
- add new data files from Ramu Ramanathan
- update to gtkextra version 0.99.12
- add installer program for win32
- fix context help bug
- renaming of various components (library is now libgretl, cli
  program is now gretlcli, some directories have been renamed)

2000-11-24 version 0.50
- MS Windows-only, was not really released

2000-11-18 version 0.40
- add critical value to printout of correlation matrix
- add capacity to read gretl databases from remote server
- add built-in data decompression with zlib
- rename exported library functions, avoiding leading underscore
- add libtool versioning

2000-11-03 version 0.32
- Add capacity to read BOX1-format data files
- Add lists of recently opened files to file menus
- fix various bugs connected with "session" concept
- fix gtkextra headers bug in make process

2000-10-20 version 0.31
- add gamma distribution to pvalue command
- fix some more bugs
- hush gtk warnings in win32 version

2000-10-15 version 0.30
- introduce experimental "session" idea
- update manual
- add "pergm" (periodogram) command.  Also see "Spectrum" under the
  GUI Variable menu
- add maxlag parameter to corrgm command; also add printing of
  Box-Pierce Q stat, and partial autocorrelations
- fix up "delete" command ("insufficient args" bug)
- clean up gnuplot background code for gnuplot controller
- delete extra variables after chow test
- minor fixes to LaTeX printing
- use proper pointers to keep track of multiple windows
- add "max p-value" statement to regression printout
- put back Durbin-Watson printout line for hccm, tsls
- fix inconsistency with docs in setting of the break point for the
  Chow test
- more fixes to csv file reading
- bug fix in freq plot after freq print
- update sample label when excluding missing obs
- update iconfilesel and gtksheet to gtk+extra-0.99.11
- configure: use installed gtkextra if available
- substantial code cleanups and speedups in GUI.

2000-06-14 version 0.2i
- improve consistency in GUI w.r.t. opening of data files and
  databases
- update manual and help files
- add "delete" command (trash last variable)
- fix potential data files paths bug
- fix hsk bug (aux regression could fail silently)
- add some data files from William Greene's book
- add "while" syntax to command loop mechanism (useful for iterated
  least squares -- tested on Greene's example 11.3 of nonlinear
  estimation). See manual.
- fix sample-length bug in add, omit
- some more informative error messages from genr
- activate "add" and "omit" for logit, probit
- make covariance matrix available for logit, probit
- add more error trapping for "add"
- code cleanup in compare.c
- can capture log-likelihood in genr with "$lnl" after logit, probit

2000-06-09 version 0.2h
- add estimation of logit and probit models and update manual
- fixes to "configure" script (gtk, termcap, paths.h) after
  compilation on HPUX
- eslclient creates user dir if it doesn't exist
- add (experimental) "parenthesizer" for genr expressions
- rearrange "summary" output
- rename Windows dll
- fix bug in "fcast" command

2000-06-01 version 0.2g
- "smpl -o" drops all observations with missing values
- binary datafiles can be saved in single or double precision (-s or
  -o flags)
- Binary datafile saving added to GUI
- Can add case markers from file to an open data set
- allow for a comment line at the top of a database .idx file (and
  display it in GUI)
- code cleanups
- delete redundant stuff
- improve some string handling functions
- fix win32 path-searching bug?

2000-05-24 version 0.2f
- updates to manual
- add handler for Penn World Table
- improve handling of native databases
- reformat some output
- add % operator in genr
- add -o flag to "smpl" command for sampling via a dummy variable
  mask.
- GUI: where appropriate, clicking on a var in the main window will
  pop its ID # into an open dialog box.
- add fcasterr to GUI, and improve graphing of forecasts
- move setobs from Data to Sample menu
- add "Gretl console" to GUI (under File menu) and update manual
- add to path-searching for datafiles called from scripts (include
  the script dir in the search)

2000-05-10 version 0.2e
- minor changes to GUI menus
- add xpm icon for X
- correct printout of t-stats for AR coefficients
- correct wasteful malloc in xpxxpy function
- better printout for F-statistic
- add discussion of NIST reference datasets to manual
- add NIST datasets to package
- add some error-checking and reporting for datafile opening
- various fixes to "genr"
- search for libesl.cfg in dir where executable resides (win32,
  Dirk's idea)
- improve handling of constants in corr, corrgm
- fix error messages from corc_hilu
- rename eslclnt.exe as eslclient.exe (win32)
- fix paths in win32 (helpfile and executable, for rerunning
  commands)

2000-05-05 version 0.2d
- improvements to manual
- fix wrong error message for zero weight var in wls
- explicit check for degeneracy in figuring summary stats
- add median(), var(), cov() to functions in genr
- add "spearman" command (rank correlation)
- add "runs" command (runs test for randomness)
- fix bug in calculation of rho hat
- fix lengths of series created by diff, etc, in relation to smpl

2000-05-01 version 0.2c
- add setobs command
- add seed command
- manual: add section on panel data, improve "genr" section
- more CSV bugfixes
- make adf, coint commands more informative
- add "paneldum" (for panel data) to genr command

2000-04-28 version 0.2b
- add fcasterr command
- many fixes in response to comments from Ramu Ramanathan and Dirk
  Eddelbuettel
- improve Makefiles
- bugfix in binary datafile handling
- update manual

2000-04-22 version 0.2a
- add arch, sim and multiply commands
- many bugfixes after running numerous test files
- further code cleanups
- improvements in printing forecasts
- fix memory leaks

2000-04-14 version 0.2
- many fixes for greater consistency with esl
- printout improvements
- internal code cleanups
- bug fixes (notably for CSV file handling)

2000-04-05 version 0.1z
- add a gui controller for gnuplot graphs
- many bugfixes
- reorganize (simplify) command-line arguments
- more updates to documentation

2000-03-27 version 0.1y
- improvements and bugfixes to CSV file handling
- improvements to "add" and "omit" commands
- add "coint" command (cointegration test)

2000-03-23 version 0.1x
- many small bugfixes
- add GNU autoconf apparatus for configuring/compiling
- updates to documentation

2000-02-29 version 0.1w
- fixes to build process
- add iconic file selector
- add "export CSV" function
- bug fixes to database reading routines

2000-02-22 version 0.1v
- add White's standard errors (hccm command)
- update help files
- Make model stats (e.g. ess) available for adding to data set in
  gui, under Model data menu.
- Add option to display values of selected variables, as well as
  "all".
- Fix pvalue in command-line client so that it does not act
  interactively when supplied with all params on the command line.
- Add facility to edit the full data header (.hdr) file in gretl
  (under Data menu).
- Activate the "Add observation" feature in ssheet; add a similar
  "Insert Observation" option.  Minimal testing so far.
- Fix (I think) bug in setup of new spreadsheet data set.
- Give "infobox" feedback when importing database series.

2000-02-13 version 0.1u
- save data files in GNU Octave format
- updates to documentation

2000-02-08 version 0.1t
- gretl adopted as GNU program
- add context-sensitive help for command dialogs
- add file, save for model output windows
- add search facility for help file, database windows

2000-02-02 version 0.1s
- Fixes to Makefiles
- Improvements to loop mode (Monte Carlo simulations)

2000-01-31 version 0.1r
- Initial public release
